#include<bits/stdc++.h>
using namespace std;

const int maxN = 1e4;
int n, m;

vector<set<int> > missing;
vector<vector<int> > g;
vector<int> len;
bitset<maxN> visited;

int bfs(int s, int e)
{
    visited = 0;
    len.assign(n, -1);
    queue<int> q;
    visited[s] = 1;
    q.push(s);
    len[s] = 0;
    while(!q.empty())
    {
        int v = q.back();
        q.pop();
        for(int next : g[v])
        {
            if(!visited[next])
            {
                visited[next] = 1;
                len[next] = len[v] + 1;
                q.push(next);
            }
        }
    }

    return len[e];
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    cin >>n >>m;
    missing.resize(n);
    g.resize(n);
    int a, b;
    for(int i = 0; i < m; i++)
    {
        cin >>a >>b;
        missing[a].insert(b);
        missing[b].insert(a);
    }

    int cc;
    for(int i = 0; i < n; i++)
    {
        cc = 0;
        for(int m : missing[i])
        {
            while(cc != m && cc < n)
            {
                g[i].emplace_back(cc++);
            }
            cc++;
        }
    }

    int q;
    cin >>q;
    while(q--)
    {
        cin >>a >>b;
        cout <<bfs(a, b) <<endl;
    }
}
