#include<bits/stdc++.h>
using namespace std;

using num = short;

const num maxN = 1e4;
num n, m;

vector<bitset<maxN> > g;
vector<vector<num> > ans;
bitset<maxN> visited;

void read()
{
    vector<set<num> > missing;
    cin >>n >>m;
    g.resize(n);
    ans.assign(n, vector<num>(n, -2));
    for(int i = 0; i < n; i++)
    {
        for(int j = 0; j < n; j++)
        {
            g[i][j] = 1;
        }
        g[i][i] = 0;
    }
    num a, b;
    for(int i = 0; i < m; i++)
    {
        cin >>a >>b;
        g[a][b] = g[b][a] = 0;
    }
    /*
    for(int i = 0; i < n; i++)
    {
        cout <<i <<" -> ";
        for(int j : g[i])
        {
            cout <<j <<" ";
        }cout <<endl;
    }
    //*/
}

num bfs(num s, num e)
{
    visited = 0;
    ans[s].assign(n, -1);
    queue<num> q;
    visited[s] = 1;
    ans[s][s] = 0;
    q.push(s);
    while(!q.empty())
    {
        num v = q.back();
        q.pop();
        for(int next = 0; next < n; next++)
        {
            if(g[next][v] && !visited[next])
            {
                visited[next] = 1;
                ans[s][next] = ans[next][s] = ans[s][v] + 1;
                q.push(next);
                //if(next == e) return ans[s][e];
            }
        }
    }

    return ans[s][e];
}

num dsu[maxN];

void bfsStart(num s)
{
    queue<num> q;
    visited[s] = 1;
    q.push(s);
    while(!q.empty())
    {
        num v = q.back();
        dsu[v] = s;
        q.pop();
        for(int next = 0; next < n; next++)
        {
            if(g[next][v] && !visited[next])
            {
                visited[next] = 1;
                q.push(next);
            }
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    read();

    visited = 0;
    for(int i = 0; i < n; i++)
    {
        if(!visited[i]) bfsStart(i);
    }

    int q;
    cin >>q;
    num a, b;
    while(q--)
    {
        cin >>a >>b;
        if(a == b)
        {
            cout <<0 <<endl;
        }
        else if(dsu[a] != dsu[b])
        {
            cout <<-1 <<endl;
        }
        else cout <<(ans[a][b] == -2 ? bfs(a, b) : ans[a][b]) <<endl;
    }
}
