#include<bits/stdc++.h>
#include "playlists.h"
using namespace std;

using bigNum = unsigned long long;

int nextSong();

int N, K, S;
double P;

vector<vector<int> > makePlaylists(int n, int k, int s, double p)
{
    N = n;
    K = k;
    S = s;
    P = p;
    vector<vector<int> > plays(n);
    for(int i = 0; i < n; i++)
    {
        if(i < s) plays[i].assign(k, i);
        else
        {
            plays[i].resize(k);
            for(int j = 0; j < (k >>1); j++)
            {
                plays[i][j] = i % s;
            }
            for(int j = k >> 1; j < k; j++)
            {
                plays[i][j] = s - 1;
            }
        }
    }

    return plays;
}

int guessPlaylist()
{
    multiset<int> songs;
    int bound = K <= 5 ? min(3, K) : 5;
    for(int i = 0; i < bound; i++) songs.insert(nextSong());

    unordered_map<int, int> m;
    for(int song : songs) m[song]++;

    auto st = songs.begin();
    if(m.size() == 1) return *st;
    else
    {
        int a = -1, a1, b ,b1;
        for(auto p : m)
        {
            if(a == -1)
            {
                a = p.first;
                a1 = p.second;
            }
            else
            {
                b = p.first;
                b1 = p.second;
            }
        }

        return a1 > b1 ? a : b;
    }
}
