#include<bits/stdc++.h>
#include "playlists.h"
using namespace std;

using bigNum = unsigned long long;

int nextSong();

int N, K, S;
double P;

vector<vector<int> > makePlaylists(int n, int k, int s, double p)
{
    N = n;
    K = k;
    S = s;
    P = p;
    vector<vector<int> > plays(n);
    for(int i = 0; i < n; i++)
    {
        if(i < s) plays[i].assign(k, i);
        else
        {
            plays[i].resize(k);
            for(int j = 0; j < (k >>1); j++)
            {
                plays[i][j] = i % s;
            }
            for(int j = k >> 1; j < k; j++)
            {
                plays[i][j] = i / s;
            }
        }
    }

    return plays;
}

int guessPlaylist()
{
    set<int> songs;
    int bound = 2;
    for(int i = 0; i < bound; i++) songs.insert(nextSong());
    auto st = songs.begin();
    if(songs.size() == 1) return *st;
    else
    {
        int a = *st;
        st++;
        int b = *st;

        return min(a * S + b, b * S + a);
    }
}
