#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <limits.h>
#include <set>
#include <map>
#include <queue>

using namespace std;

int n;
int Count=0;
struct Point
{
	int x,y,z;
	Point(int X,int Y,int Z)
	{
		x=X;
		y=Y;
		z=Z;
	}
};

bool closed[60][60][60];

vector<Point> points;

void solve()
{
	Point m=Point(0,0,0);
	for(int i=0;i<n;i++)
	{
		m=points[i];
		if(m.x>=1 && closed[m.x-1][m.y][m.z])Count--;
		if(m.y>=1 && closed[m.x][m.y-1][m.z])Count--;
		if(m.z>=1 && closed[m.x][m.y][m.z-1])Count--;
		if(m.x<49 && closed[m.x+1][m.y][m.z])Count--;
		if(m.y<49 && closed[m.x][m.y+1][m.z])Count--;
		if(m.z<49 && closed[m.x][m.y][m.z+1])Count--;		
	}
	
	queue<Point> que;
	int index=0;
	while(que.empty()&&index<n)
	{
		m=points[index];
		if(m.x>=1 && !closed[m.x-1][m.y][m.z])que.push( Point(m.x-1, m.y, m.z) );
		if(m.y>=1 && !closed[m.x][m.y-1][m.z])que.push( Point(m.x, m.y-1, m.z) );
		if(m.z>=1 && !closed[m.x][m.y][m.z-1])que.push( Point(m.x, m.y, m.z-1) );
		if(m.x<49 && !closed[m.x+1][m.y][m.z])que.push( Point(m.x+1, m.y, m.z) );
		if(m.y<49 && !closed[m.x][m.y+1][m.z])que.push( Point(m.x, m.y+1, m.z) );
		if(m.z<49 && !closed[m.x][m.y][m.z+1])que.push( Point(m.x, m.y, m.z+1) );
		index++;
	}
	int closedN;
	while(!que.empty())
	{
		m=que.front();
		que.pop();
		if(m.x<0||m.y<0||m.z<0||m.x>49||m.y>49||m.z>49||closed[m.x][m.y][m.z])
		{
			que.pop();
			continue;
		}
		closedN=0;
		if(m.x>=1 && closed[m.x-1][m.y][m.z])closedN++;
		if(m.y>=1 && closed[m.x][m.y-1][m.z])closedN++;
		if(m.z>=1 && closed[m.x][m.y][m.z-1])closedN++;
		if(m.x<49 && closed[m.x+1][m.y][m.z])closedN++;
		if(m.y<49 && closed[m.x][m.y+1][m.z])closedN++;
		if(m.z<49 && closed[m.x][m.y][m.z+1])closedN++;
		if(closedN==4)Count-=2;
		if(closedN==5)Count-=4;
		if(closedN==6)Count-=6;
		if(closedN>=3)closed[m.x][m.y][m.z]=true;
		else continue;
		if(m.x>=1 && !closed[m.x-1][m.y][m.z])que.push( Point(m.x-1, m.y, m.z) );
		if(m.y>=1 && !closed[m.x][m.y-1][m.z])que.push( Point(m.x, m.y-1, m.z) );
		if(m.z>=1 && !closed[m.x][m.y][m.z-1])que.push( Point(m.x, m.y, m.z-1) );
		if(m.x<49 && !closed[m.x+1][m.y][m.z])que.push( Point(m.x+1, m.y, m.z) );
		if(m.y<49 && !closed[m.x][m.y+1][m.z])que.push( Point(m.x, m.y+1, m.z) );
		if(m.z<49 && !closed[m.x][m.y][m.z+1])que.push( Point(m.x, m.y, m.z+1) );
	}
	cout<<Count<<endl;
}

void init()
{
	int x,y,z;
	cin>>n;
	for(int i=0;i<n;i++)
	{
		cin>>x>>y>>z;
		closed[x][y][z]=true;
		Count+=6;
		points.push_back(Point(x,y,z));
	}
	
}

int main()
{
	init();
	solve();
}
