#include<iostream>
#include<cstdio>
#include<algorithm>
#include<queue>
using namespace std;

int mat[709][709];
int n,m,q;
int used[709];
queue<int> spis;

void nullify()
{
	while(!spis.empty()) spis.pop();
	for(int i = 0; i < n; i++) used[i] = 0; 
}

int query(int from, int to)
{
	nullify();
	
	int level = 1,br = 1;
	spis.push(from);
	int node;	
	
	while(!spis.empty())
	{
		node = spis.front();
		used[node] = 1;
		spis.pop();
		br--;
		//printf("node = %d\n",node);
		for(int i = 0; i < n; i++)
		{
			if(mat[node][i] == 1 && used[i]==0)
			{
				if(i == to) return level;
				spis.push(i);
			}
		}
		if(br == 0)
		{
			br = spis.size();
			level++;
		}	
	}
	
	return -1;
	
}

void init()
{
	scanf("%d%d",&n,&m);
	
	for(int i = 0; i < n; i++)
	{
		for(int j = 0; j < n; j++)
		{
			mat[i][j] = 1;
		}
	}
	
	int a, b;
	
	for(int i = 0; i < m; i++)
	{
		scanf("%d%d",&a,&b);
		mat[a][b] = mat[b][a] = 0;
	}
	
	scanf("%d",&q);
	for(int i = 0; i < q; i++)
	{
		scanf("%d%d",&a,&b);
		if(a == b) printf("0\n");
		else cout<<query(a,b)<<endl;
	}
	
}

int main()
{
	init();
}
