#include<iostream>
#include<cstdio>
#include<algorithm>
using namespace std;

struct dim
{
	int x,y,z;
};

int n;
dim r[53];
int ya[53];

bool is_there(int x0, int y0,int p)
{
	for(int i = p+1; i < n; i++)
	{
		if(x0 == r[i].x && y0 == r[i].y) return true;
	}
	return false;
}

void solve()
{
	//count hight
	ya[r[0].y] = 6; 
	for(int i = 1; i < n; i++)
	{
		if(r[i].y == r[i-1].y)
		{
			if(r[i].x - r[i-1].x == 1) 
			{
				ya[r[i].y]+=4;
			}
			else
			{
				ya[r[i].y]+=6;
			}
		}
		else//smenqm x-a
		{
			ya[r[i].y] = 6;
		}	
	}
	
	//merge rooms
	int ans = ya[r[0].y], cur = r[0].y;
	for(int i = 0; i < n; i++)	
	{
		if(cur != r[i].y)
		{
			cur = r[i].y;
			ans += ya[r[i].y];
		}
		if(is_there(r[i].x, r[i].y-1,i) == true) ans = ans - 2;
	}
	cout<<ans<<endl;
}

bool cmp(dim a, dim b)
{
	if(a.y == b.y) return a.x < b.x;
	return a.y < b.y;
	
}

void init()
{
	scanf("%d",&n);
	for(int i = 0; i < n; i++)
	{
		scanf("%d%d%d",&r[i].x,&r[i].y, &r[i].z);
	}
	sort(r,r+n,cmp);
	solve();
}

int main()
{
	init();
}

/*
9
0 0 0
0 1 0 
0 3 0
1 0 0 
1 1 0
1 2 0 
1 3 0
3 0 0
3 2 0

40

7
0 0 0
0 1 0 
0 3 0
1 0 0 
1 1 0
1 2 0 
1 3 0

28

4
0 0 0
0 1 0
1 0 0
1 1 0

16

1
0 0 0

6

6
0 0 0
1 0 0
2 0 0 
4 0 0
8 0 0
9 0 0 

30

3
4 0 0
8 0 0
9 0 0 

16

7
1 1 0 
1 0 0
1 2 0 
1 3 0
2 1 0
2 2 0
3 0 0
 
30

*/
