#include<iostream>
#include<cstdio>
#include<algorithm>
using namespace std;

struct dim
{
	int x,y,z;
};

int n;
dim r[53];
int xa[53];

bool is_there(int x0, int y0,int p)
{
	for(int i = 0; i < n; i++)
	{
		if(x0 == r[i].x && y0==r[i].y) return true;
	}
	return false;
}

void solve()
{
	//count hight
	xa[r[0].x] = 6; 
	for(int i = 1; i < n; i++)
	{
		if(r[i].x == r[i-1].x)
		{
			if(r[i].y - r[i-1].y == 1) 
			{
				xa[r[i].x]+=4;
			}
			else
			{
				xa[r[i].x]+=6;
			}
		}
		else//smenqm x-a
		{
			xa[r[i].x] = 6;
		}	
	}
	
	//merge rooms
	int ans = xa[r[0].x], cur = r[0].x;
	for(int i = 0; i < n; i++)	
	{
		if(cur != r[i].x)
		{
			cur = r[i].x;
			ans += xa[r[i].x];
		}
		if(is_there(r[i].x+1, r[i].y,i) == true) ans = ans - 2;
	}
	cout<<ans<<endl;
}

bool cmp(dim a, dim b)
{
	if(a.x == b.x) return a.y < b.y;
	return a.x < b.x;
	
}

void init()
{
	scanf("%d",&n);
	for(int i = 0; i < n; i++)
	{
		scanf("%d%d%d",&r[i].x,&r[i].y, &r[i].z);
	}
	sort(r,r+n,cmp);
	solve();
}

int main()
{
	init();
}

/*
9
0 0 0
0 1 0 
0 3 0
1 0 0 
1 1 0
1 2 0 
1 3 0
3 0 0
3 2 0

40

7
0 0 0
0 1 0 
0 3 0
1 0 0 
1 1 0
1 2 0 
1 3 0

28

4
0 0 0
0 1 0
1 0 0
1 1 0

16

1
0 0 0

6

6
0 0 0
1 0 0
2 0 0 
4 0 0
8 0 0
9 0 0 

30

3
4 0 0
8 0 0
9 0 0 

16

7
1 1 0 
1 0 0
1 2 0 
1 3 0
2 1 0
2 2 0
3 0 0
 
30

*/
