#include <bits/stdc++.h>
using namespace std;

int n, m;
const int MAXN = 2.5e3;

vector<int> nbs[MAXN];

int dist[MAXN][MAXN];

unordered_set<int> missing[MAXN];

bool ran_bfs[MAXN];

void bfs(int from, int to) {
	queue<int> q;
	q.push(from);
	dist[from][from] = 0;
	int ans = numeric_limits<int>::max();
	while(!q.empty()) {
		int curr_node = q.front();
		q.pop();
		/*if(ran_bfs[curr_node]) {
			if(dist[curr_node][to] == -1) {
				dist[from][to] = -1;
				return;
			}
			ans = min(ans, dist[from][curr_node] + dist[curr_node][to]);
			continue;
		}*/
		for(int curr_nb : nbs[curr_node])
			if(dist[from][curr_nb] == -1) {
				dist[from][curr_nb] = dist[from][curr_node] + 1;
				q.push(curr_nb);
			}
	}
	/*if(dist[from][to] == -1 && ans != numeric_limits<int>::max()) {
		dist[from][to] = ans;
		return;
	}
	dist[from][to] = min(dist[from][to], ans);*/
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	memset(dist, -1, sizeof(dist));

	//cout << MAXN << endl;

	cin >> n >> m;
	for(int i = 0; i < m; ++i) {
		int from, to;
		cin >> from >> to;
		missing[from].insert(to);
		missing[to].insert(from);
	}

	/*for(int i = 0; i < n; ++i)
		for(int j = 0; j < n; ++j)
			if(i != j && missing[i].find(j) == missing[i].end())
				nbs[i].push_back(j);*/

	/*for(int i = 0; i < n; ++i) {
		cout << i << " nbs: ";
		for(int j = 0; j < nbs[i].size(); ++j) {
			cout << nbs[i][j] << " ";
		}
		cout << endl;
	}*/

	int q;
	cin >> q;
	for(int i = 0; i < q; ++i) {
		int from, to;
		cin >> from >> to;
		if(!ran_bfs[from]) {
			bfs(from, to);
			ran_bfs[from] = true;
		}
		//cout << dist[from][to] << endl;
	}

	return 0;
}
