#include "playlists.h"
#include <bits/stdc++.h>

using namespace std;

const int MAXN = 100;

unordered_map<int, int> songs[MAXN];

double gp;

int tn;

vector<vector<int>> makePlaylists(int n, int k, int s, double p) {
	gp = p;
	tn = n;
	vector<vector<int>> ans;
	int num_songs = 1;
	for(int i = 0; i < n; ++i) {
		vector<int> currp;
		for(int j = 0; j < k; ++j) {
			int csong = rand() % s;
			currp.push_back(csong);
			if(songs[i].find(csong) == songs[i].end())
				songs[i][csong] = 1;
			else
				++songs[i][csong];
		}
		ans.push_back(currp);
	}
}

int guessPlaylist() {
	bool used[MAXN];
	memset(used, false, sizeof(used));
	int num_used = 0;
	unordered_map<int, int> cpl;

	while(true) {
		if(num_used / (double)tn > gp) {
			for(int i = 0; i < tn; ++i)
				if(!used[i]) {
					return i;
				}
			break;
		}
		int csong = nextSong();
		if(cpl.find(csong) == cpl.end())
			cpl[csong] = 1;
		else
			++cpl[csong];
		for(int i = 0; i < tn; ++i ) {
			if(!used[i]) {
				if(songs[i].find(csong) == songs[i].end()) {
					used[i] = true;
					++num_used;
					continue;
				}
				if(songs[i][csong] < cpl[csong])  {
					used[i] = true;
					++num_used;
					continue;
				}
			}
		}
	}
}
