#include<bits/stdc++.h>
using namespace std;

const int nmax=1e4+42,MX=1e6+42;
int n,m;

unordered_set<int> adj[nmax];

vector< pair<int,int> > mem[nmax];

int outp[MX];

set<int> active;
int dist[nmax];

queue< pair<int,int> > q;

void solve(int source)
{
    memset(dist,-1,sizeof(dist));

    set<int> active={};
    for(int i=1;i<=n;i++)active.insert(i);

    active.erase(source);

    //cout<<"solve "<<source<<endl;

    q.push({source,0});

    while(q.size())
    {
        pair<int,int> tp=q.front();

        q.pop();

        dist[tp.first]=tp.second;

        //cout<<"dist "<<tp.first<<" -> "<<tp.second<<endl;

        int prv=0;

        while(1)
        {
            set<int>::iterator it=active.upper_bound(prv);

            if(it==active.end())break;

            int w=*it;

            prv=w;

            if(adj[tp.first].count(w))continue;

            active.erase(w);

            q.push({w,tp.second+1});
        }
    }

    //cout<<"---"<<endl;

    for(auto w:mem[source])
        outp[w.second]=dist[w.first];
}
int main()
{
    scanf("%i%i",&n,&m);

    for(int i=1;i<=m;i++)
    {
        int u,v;

        scanf("%i%i",&u,&v);
        u++;
        v++;

        adj[u].insert(v);
        adj[v].insert(u);
    }

    int q;
    scanf("%i",&q);

    for(int i=1;i<=q;i++)
    {
        int u,v;

        scanf("%i%i",&u,&v);
        u++;
        v++;

        mem[u].push_back({v,i});
    }

    for(int i=1;i<=n;i++)
        if(mem[i].size())
            solve(i);

    for(int i=1;i<=q;i++)
        printf("%i\n",outp[i]);

    return 0;
}
