#include<bits/stdc++.h>
using namespace std;

const int nmax=1e4+42,MX=1e6+42;
int n,m;

vector<int> adj[nmax];

vector< pair<int,int> > mem[nmax];

int outp[MX];

vector<int> active,help;
int dist[nmax];

queue< pair<int,int> > q;

bool in(int id,int val)
{
    int pos=lower_bound(adj[id].begin(),adj[id].end(),val)-adj[id].begin();

    if(pos<adj[id].size())return adj[id][pos]==val;

    return 0;
}
void solve(int source)
{
    memset(dist,-1,sizeof(dist));

    active={};

    for(int i=1;i<=n;i++)
        if(i!=source)active.push_back(i);

    //cout<<"solve "<<source<<endl;

    q.push({source,0});

    while(q.size())
    {
        pair<int,int> tp=q.front();

        q.pop();

        dist[tp.first]=tp.second;

        //cout<<"dist "<<tp.first<<" -> "<<tp.second<<endl;

        help={};

        for(auto w:active)
        {
            //if(pos<adj[tp.first].size())cout<<"blocked "<<adj[tp.first][pos]<<" tried "<<w<<endl;

            if(in(tp.first,w))
            {
                help.push_back(w);

                continue;
            }

            q.push({w,tp.second+1});
        }

        active=help;
    }

    //cout<<"---"<<endl;

    for(auto w:mem[source])
        outp[w.second]=dist[w.first];
}
int main()
{
    scanf("%i%i",&n,&m);

    for(int i=1;i<=m;i++)
    {
        int u,v;

        scanf("%i%i",&u,&v);
        u++;
        v++;

        adj[u].push_back(v);
        adj[v].push_back(u);
    }

    for(int i=1;i<=n;i++)sort(adj[i].begin(),adj[i].end());

    int q;
    scanf("%i",&q);

    for(int i=1;i<=q;i++)
    {
        int u,v;

        scanf("%i%i",&u,&v);
        u++;
        v++;

        mem[u].push_back({v,i});
    }

    for(int i=1;i<=n;i++)
        if(mem[i].size())
            solve(i);

    for(int i=1;i<=q;i++)
        printf("%i\n",outp[i]);

    return 0;
}
