#include<iostream>
#include<vector>
#include<queue>
using namespace std;

const int MAXN = 800;
const int NA = -1;

int n, m;
bool paths[MAXN][MAXN];
int answ[MAXN][MAXN];

vector<int> graph[MAXN];

int q;
queue< pair<int, int> > que;
bool bt[MAXN][MAXN];
void solve(int s, int c, int e, int d) // s = start ; c = current ; e = end ; d = distance
{
    bt[s][c]=true;
    //cout<<s<<" "<<c<<" "<<e<<" "<<d<<endl;

    if(c==e && answ[s][e]==NA)
    {
        answ[s][e]=d; answ[e][s]=answ[s][e];
        return;
    }

    if(answ[s][c]==NA) { answ[s][c]=d; answ[c][s]=d;}

    if(answ[c][e]!=NA && answ[c][s]==NA && answ[s][e]==NA)
    {
        answ[s][e]=answ[c][e]+d;
        answ[e][s]=answ[s][e];
        return;
    }


    //
    for(int i=0; i<graph[c].size(); ++i)
    {
        if(!bt[s][graph[c][i]])
            que.push(make_pair(graph[c][i], d));
    }

    //cout<<"beep4"<<endl;
    while(!que.empty() && answ[s][e]==NA)
    {
        pair<int, int> t=que.front();
        que.pop();
        solve(s, t.first, e, t.second+1);
    }
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin>>n>>m;

    int a, b;
    for(int i=0; i<m; ++i)
    {
        cin>>a>>b;
        paths[a][b]=1;
        paths[b][a]=1;
    }

   // cout<<endl;
    for(int i=0; i<n; ++i)
        for(int j=0; j<n; ++j)
            if(!paths[i][j])
            {
                graph[i].push_back(j);
                graph[j].push_back(i);
                //cout<<i<<" "<<j<<endl;
            }

    cin>>q;

    for(int i=0; i<n; ++i)
        for(int j=0; j<n; ++j)
            answ[i][j]=NA;

    int c, d;
    for(int i=0; i<q; ++i)
    {
        cin>>c>>d;

        if(answ[c][d]!=NA) { cout<<answ[c][d]<<endl; continue; }
        if(c==d && !paths[d][d]) { cout<<0<<endl; continue; }

        solve(c, c, d, 0);

        while(!que.empty()) que.pop();

        answ[d][c]=answ[c][d];
        cout<<answ[c][d]<<endl;
    }

    return 0;
}
