#include <iostream>
#include <vector>
#include <queue>
using namespace std;

int n, m;
bool fl[10001][10001];
bool f[10001];
vector<int> v[10001];

int main()
{
    cin>>n>>m;
    int i, j;
    for(i=1;i<=m;i++){
        int p, q;
        cin>>p>>q;
        fl[p][q] = 1;
        fl[q][p] = 1;
    }
    for(i=0;i<n;i++){
        for(j=0;j<n;j++){
            if(i != j && fl[i][j] == 0) v[i].push_back(j);
        }
    }

    /*for(i=0;i<n;i++){
        cout<<i<<"  ";
        for(j=0;j<v[i].size();j++){
            cout<<v[i][j]<<" ";
        }
        cout<<endl;
    }*/
    int t;
    cin>>t;
    for(i=1;i<=t;i++){
        int p1, p2;
        cin>>p1>>p2;
        if(p1 == p2) { cout<<0<<endl;   continue;  }
        queue<int> q1;
        queue<int> q2;
        q1.push(p1);
        q2.push(0);
        int ans=0;
        for(j=0;j<n;j++) f[j] = 0;
        f[p1] = 1;
        while(ans == 0){
            if(q1.empty())  { ans = -1;  break; }
            int fr = q1.front();
            int d = q2.front();

            for(j=0;j<v[fr].size();j++){
                if(f[v[fr][j]] == 0){
                    if(v[fr][j] == p2) {
                        ans = d+1;
                        break;
                    }
                    f[v[fr][j]] = 1;
                    q1.push(v[fr][j]);
                    q2.push(d+1);
                }
            }


            q1.pop();  q2.pop();
        }

        cout<<ans<<endl;
    }




    return 0;
}
