#include <bits/stdc++.h>
#define MAXN 1000000
using namespace std;

vector<vector<int>> el;
vector<pair<int, int>> res;
vector<int> ans;
bool visited[MAXN];

void addEdge(int a, int b) {
    el[a].push_back(b);
    el[b].push_back(a);
}

int bfs(int start, int e, int c) {
    queue<int> q;
    visited[start] = true;
    q.push(start);

    while(!q.empty()) {
        int f = q.front();
        q.pop();

        for(auto i=el[f].begin(); i!=el[f].end(); i++) {

         if (*i == start || *i == e)
            c++;
         if (!visited[*i]) {

            q.push(*i);
            visited[*i] = true;
         }
        }
    }

    if (c == 0) c=-1;
    if (start == e)
        c = 0;
    return c;
}

int main()
{

    int n, m, q, a, b;

    el.assign(m, vector<int>());
    res.assign(m, pair<int, int>());
    ans.assign(MAXN, 0);

    cin >> n >> m;

    int f, e;
    for (int i=0; i<m; i++) {
        cin >> f >> e;
        addEdge(f, e);
    }

    cin >> q;
    for(int i=0; i<q; i++) {
        cin >> a >> b;
        res[i].first = a;
        res[i].second = b;
    }

    for(int i=0; i<q; i++)
    {
         ans[i] = bfs(res[i].first, res[i].second, ans[i]);
         cout << ans[i] << endl;
    }

    return 0;
}
