#include <bits/stdc++.h>
using namespace std;
int t[700][700];
long long n, m, a, b, q, curr;
bool visited[700];
vector<int>vec[700];
int levels[700];
int query(int a, int b)
{
    if(t[a][b]) return t[a][b];
    fill_n(visited, 700, false);
    fill_n(levels, 700, -1);
    levels[a]=0;
    queue<int> q;
    q.push(a);
    while(!q.empty())
    {
        curr = q.front();
        q.pop();
        if(visited[curr]) continue;
        visited[curr] = true;
        if(curr == b) break;
        for(int i=0; i<vec[curr].size(); i++)
        {
            if(!visited[vec[curr][i]])
            {
                    q.push(vec[curr][i]);
                    if(levels[vec[curr][i]]==-1) levels[vec[curr][i]] = levels[curr]+1;
                    else levels[vec[curr][i]] = min(levels[curr]+1, levels[vec[curr][i]]);
            }
        }
    }
    t[a][b] = t[b][a] = levels[b];
    return levels[b];
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cin>>n>>m;
    for(int i=0; i<m; i++)
    {
        cin>>a>>b;
        t[a][b]=t[b][a]=1;
    }
    for(int i=0; i<n; i++)
    {
        for(int j=i+1; j<n; j++)
        {
            if(!t[i][j]&&!t[j][i])
            {
                vec[i].push_back(j);
                vec[j].push_back(i);
            }
        }
    }
    cin>>q;
    for(int i=0; i<q; i++)
    {
        cin>>a>>b;
        if(a==b) cout<<0<<endl;
        else cout<<query(a, b)<<endl;
    }
    return 0;
}
