#include<cstdio>
#include<iostream>
#include<cstring>
using namespace std;
#define MAXN 10000
int G[MAXN*(MAXN+1)/2];
int N,M,Q,a,b;
int &F(int i,int j)
{
	if(i>j)swap(i,j);
	return G[i*N+i*(1-i)/2+j+1-i];
}
void floyd()
{
	int i,j,k;
	for(k=0;k<N;k++)
		for(i=0;i<N-1;i++)
			if(i!=k)
				for(j=i+1;j<N;j++)
					if(F(i,j)>F(i,k)+F(k,j))F(i,j)=F(i,k)+F(k,j);
}
void init()
{
	int i,j;
	scanf("%d %d",&N,&M);
	for(i=0;i<N;i++)
		for(j=i;j<N;j++)	
			F(i,j)=(i!=j);
	for(i=0;i<M;i++)
	{
		scanf("%d %d",&a,&b);
		F(a,b)=MAXN;
	}
}
void solve()
{
	int i;
	init();
	floyd();
	scanf("%d",&Q);
	for(i=0;i<Q;i++)
	{
		scanf("%d %d",&a,&b);
		printf("%d\n",(F(a,b)>=MAXN)?-1:F(a,b));
	}
}
int main()
{
	solve();
}
