#include<bits/stdc++.h>
#define f first
#define s second
#define pb push_back
#define eb emplace_back

#include "playlists.h"

using namespace std;

const int MAXN = 100 + 5;
int n, k, s;
double p;
vector<vector<int>> pl;
int tog[MAXN][MAXN];
int wh[MAXN][MAXN];

vector<vector<int>> makePlaylists(int N, int K, int S, double P) {
    n = N, k = K, s = S, p = P;
    pl.resize(n);

    vector<int> gcnt(s, 0);
    for (int i=0; i<n; i++) {
        pl[i].resize(k);
        vector<int> cnt = gcnt;

        for (int j=0; j<k; j++) {
            int pos = 0;
            for (int z=0; z<s; z++) {
                if (cnt[z] < cnt[pos]) {
                    pos = z;
                }
            }

            pl[i][j] = pos;
            wh[pos][i]++;
            for (int z=0; z<s; z++) {
                cnt[z] += tog[z][pos];
                cnt[pos] += tog[z][pos];
                if (z == pos) {
                    cnt[z] -= tog[z][pos];
                }
            }
            for (int z=0; z<j; z++) {
                tog[pl[i][z]][pos]++;
                tog[pos][pl[i][z]]++;
            }
            gcnt[pos]++;
        }
    }

    /*for (int i=0; i<pl.size(); i++) {
        cerr<<i<<" - ";
        for (int j=0; j<pl[i].size(); j++) {
            cerr<<pl[i][j]<<' ';
        }
        cerr<<endl;
    }
    cerr<<"done"<<endl;*/

    return pl;
}

int guessPlaylist() {
    list<int> cs;
    for (int i=0; i<n; i++) {
        cs.pb(i);
    }

    vector<int> cnt(s);
    while (true) {
        int curr = nextSong();
        cnt[curr]++;

        //cerr<<123<<endl;
        auto id = cs.begin();
        while (id != cs.end()) {
            auto id2 = id++;
            if (wh[curr][*id2] < cnt[curr]) {
                cs.erase(id2);
            }
        }
        if ((double)1 / (n / cs.size()) > p) {
            //cerr<<*cs.begin()<<endl;
            return *cs.begin();
        }
    }
}