#include<bits/stdc++.h>
#define f first
#define s second
#define pb push_back
#define eb emplace_back

#include "playlists.h"

using namespace std;

const int MAXN = 100 + 5;
int n, k, s;
double p;
int num;
vector<vector<int>> pl;
int wh[MAXN][MAXN];

vector<vector<int>> makePlaylists(int N, int K, int S, double P) {
    n = N, k = K, s = S, p = P;
    pl.resize(n);

    for (int i=0; i<pl.size(); i++) {
        pl[i].resize(k);
        for (int j=0; j<pl[i].size(); j++) {
            pl[i][j] = rand() % s;
            wh[pl[i][j]][i]++;
        }
    }

    for (int i=0; i<pl.size(); i++) {
        cerr<<i<<" - ";
        for (int j=0; j<pl[i].size(); j++) {
            cerr<<pl[i][j]<<' ';
        }
        cerr<<endl;
    }
    cerr<<"done"<<endl;

    return pl;
}

int guessPlaylist() {
    list<int> cs;
    for (int i=0; i<n; i++) {
        cs.pb(i);
    }

    int ch = 0;
    vector<int> cnt(s);
    while (ch < k) {
        int curr = nextSong();
        cnt[curr]++;

        //cerr<<123<<endl;
        auto id = cs.begin();
        while (id != cs.end()) {
            auto id2 = id++;
            if (wh[curr][*id2] < cnt[curr]) {
                cs.erase(id2);
            }
        }
        if ((double)1 / cs.size() > p) {
            //cerr<<*cs.begin()<<endl;
            return *cs.begin();
        }
        ch++;
    }
    return *cs.begin();
}