#include<bits/stdc++.h>
#define f first
#define s second
#define pb push_back
#define eb emplace_back

/*
#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse4")
#pragma GCC target("avx2")
*/

const int MAXX = 50 + 5;
const int MAXN = MAXX * MAXX * MAXX;

int n;
struct block {
    int x, y, z;
};
block b[MAXN];
bool bad[MAXX][MAXX][MAXX];
int ans;

using namespace std;

void input() {
    cin>>n;
    for (int i=0; i<n; i++) {
        cin>>b[i].x>>b[i].y>>b[i].z;
    }
}

void output() {
    cout<<ans<<endl;
}

int calcNear(int x, int y, int z) {
    int cnt = 0;
    if (x > 0 && bad[x-1][y][z]) {
        cnt++;
    } if (bad[x+1][y][z]) {
        cnt++;
    } if (y > 0 && bad[x][y-1][z]) {
        cnt++;
    } if (bad[x][y+1][z]) {
        cnt++;
    } if (z > 0 && bad[x][y][z-1]) {
        cnt++;
    } if (bad[x][y][z+1]) {
        cnt++;
    }

    return cnt;
}

void updateNear(int x, int y, int z);

void updateCurr(int x, int y, int z) {
    if (x < 0 || x >= 50 || y < 0 || y >= 50 || bad[x][y][z]) {
        return;
    }

    int cnt = calcNear(x, y, z);

    if (cnt >= 3) {
        bad[x][y][z] = true;
        ans += 6 - 2*cnt;
        updateNear(x, y, z);
    }
}

void updateNear(int x, int y, int z) {
    updateCurr(x-1, y, z);
    updateCurr(x+1, y, z);
    updateCurr(x, y-1, z);
    updateCurr(x, y+1, z);
}

void solve() {
    for (int i=0; i<n; i++) {
        bad[b[i].x][b[i].y][b[i].z] = true;
        ans += 6 - 2*calcNear(b[i].x, b[i].y, b[i].z);
        updateNear(b[i].x, b[i].y, b[i].z);
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    input();
    solve();
    output();
    return 0;
}

