#include<bits/stdc++.h>
#define f first
#define s second
#define pb push_back
#define eb emplace_back

/*
#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse4")
#pragma GCC target("avx2")
*/

using namespace std;

const int MAXX = 50 + 5;
const int MAXN = MAXX * MAXX * MAXX;

int n;
struct block {
    int x, y, z;
};
block b[MAXN];
bool bad[MAXX][MAXX][MAXX];
int ans;


void input() {
    cin>>n;
    for (int i=0; i<n; i++) {
        cin>>b[i].x>>b[i].y>>b[i].z;
    }
}

void output() {
    cout<<ans<<endl;
}

int calcNear(int x, int y, int z) {
    int cnt = 0;
    if (x > 0 && bad[x-1][y][z]) {
        cnt++;
    } if (bad[x+1][y][z]) {
        cnt++;
    } if (y > 0 && bad[x][y-1][z]) {
        cnt++;
    } if (bad[x][y+1][z]) {
        cnt++;
    } if (z > 0 && bad[x][y][z-1]) {
        cnt++;
    } if (bad[x][y][z+1]) {
        cnt++;
    }

    return cnt;
}

void updateNear(int x, int y, int z);

void becomeBad(int x, int y, int z, int cnt) {
    //cerr<<x<<' '<<y<<' '<<z<<endl;
    bad[x][y][z] = true;
    ans += 6 - 2*cnt;
    updateNear(x, y, z);
}

void updateCurr(int x, int y, int z) {
    if (x < 0 || x >= 50 || y < 0 || y >= 50 || z < 0 || z >= 50 || bad[x][y][z]) {
        return;
    }

    int cnt = calcNear(x, y, z);
    //if (x == 3 && y == 2) cerr<<cnt<<endl;
    if (cnt >= 3) {
        becomeBad(x, y, z, cnt);
    }
}

void updateNear(int x, int y, int z) {
    updateCurr(x-1, y, z);
    updateCurr(x+1, y, z);
    updateCurr(x, y-1, z);
    updateCurr(x, y+1, z);
    updateCurr(x, y, z-1);
    updateCurr(x, y, z+1);
}

void solve() {
    for (int i=0; i<n; i++) {
        becomeBad(b[i].x, b[i].y, b[i].z, calcNear(b[i].x, b[i].y, b[i].z));
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    input();
    solve();
    output();
    return 0;
}


/*
11
0 1 0
0 2 0
0 3 0
1 0 0
1 4 0
2 0 0
2 4 0
3 1 0
3 2 0
3 3 0
2 2 0
*/
