#include <bits/stdc++.h>
#include "playlists.h"

using namespace std;
typedef long long ll;
template<class T> void check_min(T &a, const T &b){ a = (a < b) ? a : b; }
template<class T> void check_max(T &a, const T &b){ a = (a > b) ? a : b; }
#define all(x) (x).begin(), (x).end()
int get_int();
ll get_ll();

int nextSong();

map<vector<int>, int> mp;
mt19937 mt(133);
int n, k, s;
double p;

vector<vector<int>> makePlaylists(int _n, int _k, int _s, double _p){
    n = _n, k = _k, s = _s, p = _p;

    vector<vector<int>> ans;
    for(int i = 0; i < n; ++i){
        vector<int> v;
        for(int i = 0; i < k; ++i)
            v.push_back(mt() % s);
        sort(all(v));
        mp[v] = i;
        ans.push_back(v);
    }
    return ans;
}

int guessPlaylist(){
    vector<int> v;
    for(int i = 0; i < k; ++i)
        v.push_back(nextSong());
    sort(all(v));
    return mp[v];
}

