#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
template<class T> void check_min(T &a, const T &b){ a = (a < b) ? a : b; }
template<class T> void check_max(T &a, const T &b){ a = (a > b) ? a : b; }
#define all(x) (x).begin(), (x).end()
int get_int();
ll get_ll();

const int MAX = 50 + 3;
const int N = MAX * MAX * MAX;

int n;
array<int, 3> p[N];
bool b[MAX][MAX];

int main(){
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    n = get_int();
    for(int i = 0; i < n; ++i){
        for(int j = 0; j < 3; ++j)
            p[i][j] = get_int();
        b[p[i][0]][p[i][1]] = true;
    }

    for(int i = 1; i < MAX - 1; ++i)
        for(int j = 1; j < MAX - 1; ++j)
            if(b[i - 1][j] && b[i + 1][j] && b[i][j - 1] && b[i][j + 1]){
                b[i][j] = true;
                ++n;
            }

    int ans = 6 * n;
    for(int i = 0; i < MAX; ++i)
    for(int j = 0; j < MAX; ++j){
        if(i != MAX - 1 && b[i][j] && b[i + 1][j]) ans -= 2;
        if(j != MAX - 1 && b[i][j] && b[i][j + 1]) ans -= 2;
    }
    cout << ans << "\n";
}

int ptr = N - 1;
char buff[N];

void next_char(){ if(++ptr == N) fread(buff, 1, N, stdin), ptr = 0; }

int get_int(){
    int ret = 0;
    for(; buff[ptr] < '0' || '9' < buff[ptr]; next_char());
    for(; '0' <= buff[ptr] && buff[ptr] <= '9'; next_char())
        ret = 10 * ret + buff[ptr] - '0';
    return ret;
}

ll get_ll(){
    ll ret = 0;
    for(; buff[ptr] < '0' || '9' < buff[ptr]; next_char());
    for(; '0' <= buff[ptr] && buff[ptr] <= '9'; next_char())
        ret = 10 * ret + buff[ptr] - '0';
    return ret;
}
