#include <bits/stdc++.h>
#pragma GCC optimize("O3")

using namespace std;
typedef long long ll;
template<class T> void check_min(T &a, const T &b){ a = (a < b) ? a : b; }
template<class T> void check_max(T &a, const T &b){ a = (a > b) ? a : b; }
#define all(x) (x).begin(), (x).end()
int get_int();
ll get_ll();

const int MAX = 15 + 3;
const int N = MAX * MAX * MAX;
clock_t timer = clock();

int n;
array<int, 3> p[N];
bool b[MAX][MAX][MAX];
bool vis[MAX][MAX][MAX];
array<int, 3> co[6] = {{1, 0, 0}, {-1, 0, 0}, {0, -1, 0}, {0, 1, 0}, {0, 0, 1}, {0, 0, -1}};

bool time_left(){
    return ((float)clock() - (float)timer) / (float) CLOCKS_PER_SEC <= 1.5;
}

bool to_add(int x, int y, int z){
    int diff = 6;
    for(auto [add_x, add_y, add_z]: co){
        int new_x = x + add_x;
        int new_y = y + add_y;
        int new_z = z + add_z;
        if(new_x < 0 || new_x >= MAX || new_y < 0 || new_y >= MAX || new_z < 0 || new_z >= MAX)
            continue;
        if(b[new_x][new_y][new_z]) diff -= 2;
    }
    return diff <= 0;
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    n = get_int();
    for(int i = 0; i < n; ++i){
        for(int j = 0; j < 3; ++j)
            p[i][j] = get_int();
        b[p[i][0]][p[i][1]][p[i][2]] = true;
    }

    int cnt = n;
    while(time_left()){
        for(int i = 0; i < MAX; ++i)
            for(int j = 0; j < MAX; ++j)
                for(int k = 0; k < MAX; ++k)
                    if(!b[i][j][k] && to_add(i, j, k)){
                        b[i][j][k] = true;
                        ++cnt;
                    }
    }

    int ans = 6 * cnt;
    for(int i = 0; i < MAX - 1; ++i)
        for(int j = 0; j < MAX - 1; ++j)
            for(int k = 0; k < MAX - 1; ++k){
                if(!b[i][j][k]) continue;
                if(b[i + 1][j][k]) ans -= 2;
                if(b[i][j + 1][k]) ans -= 2;
                if(b[i][j][k + 1]) ans -= 2;
            }
    cout << ans << "\n";
}

int ptr = N - 1;
char buff[N];

void next_char(){ if(++ptr == N) fread(buff, 1, N, stdin), ptr = 0; }

int get_int(){
    int ret = 0;
    for(; buff[ptr] < '0' || '9' < buff[ptr]; next_char());
    for(; '0' <= buff[ptr] && buff[ptr] <= '9'; next_char())
        ret = 10 * ret + buff[ptr] - '0';
    return ret;
}

ll get_ll(){
    ll ret = 0;
    for(; buff[ptr] < '0' || '9' < buff[ptr]; next_char());
    for(; '0' <= buff[ptr] && buff[ptr] <= '9'; next_char())
        ret = 10 * ret + buff[ptr] - '0';
    return ret;
}
