#include<bits/stdc++.h>
using namespace std;
const long long MAXN=10005;
long long dist[MAXN][MAXN], N, M, x, y, Q;
bool visited[MAXN], used[MAXN];
unordered_set<long long> s[MAXN];
queue<long long> q;
void bfs(long long st){
    while(!q.empty())q.pop();
    memset(used, 0, sizeof(used));
    used[st]=1;
    dist[st][st]=1;
    q.push(st);
    while(!q.empty()){
        int curr=q.front();
        for(auto it=s[curr].begin(); it!=s[curr].end(); it++){
            if(!used[*it]){
                used[*it]=1;
                dist[st][*it]=dist[st][curr]+1;
                q.push(*it);
            }
        }
        q.pop();
    }
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin>>N>>M;
    for(long long i=0; i<N; i++){
        for(long long j=0; j<N; j++){
            if(i!=j)s[i].insert(j);
        }
    }
    for(long long i=0; i<M; i++){
        cin>>x>>y;
        s[x].erase(y);
        s[y].erase(x);
    }
    cin>>Q;
    for(long long i=0; i<Q; i++){
        cin>>x>>y;
        if(visited[x]){
            if(dist[x][y]>0){
                cout<<dist[x][y]-1<<endl;
            }else cout<<"-1"<<endl;
        }else if(visited[y]){
            if(dist[y][x]>0){
                cout<<dist[y][x]-1<<endl;
            }else cout<<"-1"<<endl;
        }else{
            bfs(x);
            visited[x]=1;
            if(dist[x][y]>0){
                cout<<dist[x][y]-1<<endl;
            }else cout<<"-1"<<endl;
        }
    }
    return 0;
}
