#include<bits/stdc++.h>
using namespace std;
const long long MAXN=10005, INF=10000000001;
long long dist[MAXN], N, M, x, y, Q;
bool visited[MAXN], used[MAXN];
long long mat[MAXN][MAXN];
queue<long long> q;
vector<long long> v[MAXN];
long long bfs(long long st, long long fin){
    while(!q.empty())q.pop();
    memset(used, 0, sizeof(used));
    memset(dist, 0, sizeof(dist));
    used[st]=1;
    dist[st]=0;
    q.push(st);
    while(!q.empty()){
        int curr=q.front();
        q.pop();
        for(long long i=0; i<N; i++){
            if(mat[curr][i]==1 and !used[i] and curr!=i){
                used[i]=1;
                dist[i]=dist[curr]+1;
                if(i==fin)return dist[i];
                q.push(i);
            }
        }
    }
    return -1;
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin>>N>>M;
    for(long long i=0; i<N; i++){
        for(long long j=0; j<N; j++)mat[i][j]=1;
    }
    for(long long i=0; i<M; i++){
        cin>>x>>y;
        mat[x][y]=0;
        mat[y][x]=0;
        v[x].push_back(y);
    }
    for(long long i=0; i<N; i++){
        if(v[i].size()>0){
            for(long long j=0; j<v[i].size(); j++){
                mat[i][v[i][j]]=bfs(i, v[i][j]);
                mat[v[i][j]][i]=mat[i][v[i][j]];
            }
        }
    }
    cin>>Q;
    for(long long i=0; i<Q; i++){
        cin>>x>>y;
        if(mat[x][y]>0 and x!=y){
            cout<<mat[x][y]<<endl;
        }else if(x==y) cout<<"0"<<endl;
        else cout<<"-1"<<endl;
    }
    return 0;
}
