#include <iostream>
#include <vector>
#include <queue>
using namespace std;
#define endl '\n'
const int MAXN=3e3+10;
vector <int> v[MAXN];
queue <int> q;
int dist[MAXN][MAXN];
bool matr[MAXN][MAXN];
void bfs(int start) {
    q.push(start);
    dist[start][start]=0;
    int x;
    while (!q.empty()) {
        x=q.front();
        q.pop();
        for (auto i:v[x]) {
            if (dist[start][i]!=-1) continue;
            dist[start][i]=dist[start][x]+1;
            q.push(i);
        }
    }
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m, a, b;
    cin >> n >> m;
    for (int i=0;i<m;i++) {
        cin >> a >> b;
        matr[a][b]=matr[b][a]=true;
    }
    for (int i=0;i<n;i++) {
        for (int j=i+1;j<n;j++) {
            if (matr[i][j]) continue;
            v[i].push_back(j);
            v[j].push_back(i);
        }
    }
    for (int i=0;i<n;i++) {
        for (int j=0;j<n;j++) dist[i][j]=-1;
        bfs(i);
    }
    int quer;
    cin >> quer;
    for (int i=0;i<quer;i++) {
        cin >> a >> b;
        cout << dist[a][b] << endl;
    }
    return 0;
}
