#include <iostream>
using namespace std;
int matr[64][64], comp[64][64];
int mov[4][2]={{1,0},{0,1},{-1,0},{0,-1}};
int maxx, maxy;
void dfs(int i, int j, int br) {
    comp[i][j]=br;
    int x, y;
    for (int k=0;k<4;k++) {
        x=i+mov[k][0];
        y=j+mov[k][1];
        if (x<0 || y<0 || x>maxx || y>maxy || !matr[x][y] || comp[x][y]) continue;
        dfs(x,y,br);
    }
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, x, y, z;
    cin >> n;
    for (int i=0;i<n;i++) {
        cin >> x >> y >> z;
        matr[x][y]=true;
        maxx=max(x,maxx);
        maxy=max(y,maxy);
    }
    int cnt;
    for (int times=0;times<250;times++) {
        for (int i=0;i<=maxx;i++) {
            for (int j=0;j<=maxy;j++) {
                if (matr[i][j]) continue;
                cnt=0;
                for (int k=0;k<4;k++) {
                    x=i+mov[k][0];
                    y=j+mov[k][1];
                    if (x<0 || y<0 || x>maxx || y>maxy) continue;
                    if (matr[x][y]) cnt++;
                }
                if (cnt>=3) matr[i][j]=true;
            }
        }
    }
    int br=1;
    cnt=0;
    for (int i=0;i<=maxx;i++) {
        for (int j=0;j<=maxy;j++) {
            if (!matr[i][j]) continue;
            cnt++;
            if (!comp[i][j]) {
                dfs(i,j,br);
                br++;
            }
        }
    }
    int ans=cnt*6;
    for (int i=0;i<=maxx;i++) {
        for (int j=0;j<=maxy;j++) {
            if (comp[i][j]==0) continue;
            for (int k=0;k<4;k++) {
                x=i+mov[k][0];
                y=j+mov[k][1];
                if (x<0 || y<0 || x>maxx || y>maxy) continue;
                if (comp[x][y]==comp[i][j]) ans--;
            }
        }
    }
    cout << ans << endl;
    return 0;
}
/**
8
0 2 0
1 1 0
2 0 0
3 1 0
4 2 0
3 3 0
2 4 0
1 3 0
**/

