#include <vector>

int nextSong();
std::vector<std::vector<int>> makePlaylists(int n, int k, int s, double p);
int guessPlaylist();

#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
template<class T, class T2> bool chkmax(T &a, const T2 &b) {return (a < b) ? a = b, 1 : 0;}
template<class T, class T2> bool chkmin(T &a, const T2 &b) {return (a > b) ? a = b, 1 : 0;}

namespace a {
int n, k, s;
double p;
int flag = -1, nmb = 1e6;
int needBits = 0, sz = 1e6;
};

vector<vector<int> > makePlaylists(int _n, int _k, int _s, double _p) {
    a::n = _n;
    a::k = _k;
    a::s = _s;
    a::p = _p;
    vector<vector<int> > ret;
    for(int i = 1; i <= a::n; i ++) {
        int need = a::n / i;
        int needBits = 0;
        while(need > (1 << needBits)) {needBits ++;}
        if(i + 2 * needBits <= a::s && chkmin(a::sz, 1 + needBits)) {
            a::flag = i;
            a::needBits = needBits;
        }
    }
    if(a::flag != -1) {
        for(int i = 0; i < a::n; i ++) {
            vector<int> now;
            int rem = i % a::flag;
            now.push_back(a::s - 1 - rem);
            int div = i / a::flag;
            for(int j = 0; j < a::needBits; j ++) {
                if(div & (1 << j)) {
                    now.push_back(2 * j + 1);
                } else {
                    now.push_back(2 * j);
                }
            }
            int szBeg = now.size();
            for(int j = szBeg; j < a::k; j ++) {
                now.push_back(now[j % szBeg]);
            }
            ret.push_back(now);
            continue;
            cout << i << ", " << rem << " " << div << " " << a::flag << ": ";
            for(auto it : now) {
                cout << it << " ";
            }
            cout << endl;
        }
    } else if((1 << a::s) > a::n) {
        for(int i = 1; i <= a::n; i ++) {
            vector<int> now;
            for(int j = 0; j < min(32, a::s); j ++) {
                if(i & (1 << j)) {
                    now.push_back(j);
                }
            }
            int szBeg = now.size();
            for(int j = szBeg; j < a::k; j ++) {
                now.push_back(now[j % szBeg]);
            }
            ret.push_back(now);
        }
    } else {
        for(int i = 0; i < a::n; i ++) {
            vector<int> now;
            int lft = i;
            for(int j = 0; j < a::k; j ++) {
                now.push_back(min(lft, a::s - 1));
                lft -= min(lft, a::s - 1);
            }
            ret.push_back(now);
        }
    }
    return ret;
}

int guessPlaylist() {
    int ans = 0;
    if(a::flag != -1) {
        set<int> st;
        int rem = 0;
        int div = 0;
        while(st.size() < a::sz) {
            int now = nextSong();
            if(st.find(now) == st.end()) {
                st.insert(now);
                if(now < 2 * a::needBits) {
                    div |= (now & 1) << (now / 2);
                } else {
                    rem = a::s - 1 - now;
                }
            }
        }
        ans = div * a::flag + rem;
        return ans;
    } else if((1 << a::s) > a::n) {
        for(int i = 0; i < a::k - 2; i ++) {
            ans |= (1 << nextSong());
        }
        return ans - 1;
    } else {
        for(int i = 0; i < a::k; i ++) {
            ans += nextSong();
        }
        return ans;
    }
}
