#include <iostream>
#include <vector>
using namespace std;

int n;
int x, y, z;
int tk[64][64];
int tkn;

int ans;

vector<pair<int, int> > offset;

void marktk()
{
    for(int i = 1; i <= 50; i++){
        for(int j = 1; j <= 50; j++){
            if(tk[i][j] == 0){
                int c = 0;
                for(auto k: offset){
                    c += tk[i+k.first][j+k.second];
                }
                if(c >= 3){
                    tk[i][j] = 1;
                    tkn++;
                }
            }
        }
    }
}

int main(){

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    offset = {{-1, 0}, {1, 0}, {0, 1}, {0, -1}};

    cin >> n;
    tkn = n;
    for(int i = 0; i < n; i++){
        cin >> x >> y >> z;
        x++;
        y++;
        tk[x][y] = 1;
    }

    for(int i = 0; i < 110; i++){
        marktk();
    }


    ans += 2*tkn;

    for(int i = 1; i <= 50; i++){
        for(int j = 1; j <= 50; j++){
            if(tk[i][j] == 1){
                int curr = 0;
                for(auto k: offset){
                    curr += 1-tk[i+k.first][j+k.second];
                }
                ans += curr;
            }
        }
    }

    cout << ans << endl;

return 0;
}
