#include <bits/stdc++.h>
#include "playlists.h"
using namespace std;

int N, K, S;
double P;
int GR [128];
double PART [128];

vector <vector <int> > makePlaylists (int n, int k, int s, double pp){
    N = n;
    K = k;
    S = s;
    P = pp;
    vector <vector <int> > p (n, vector <int> (k, 0));
    S -= S % 2;
    int x = N / (S / 2), r = N % (S / 2);
    int l = 0;
    for (int gr = 0; gr < S / 2; gr ++){
        int cnt = (gr < r ? x + 1 : x);
        double step = 1.0 / (cnt - 1), part = 0;
        for (int i = 0; i < cnt; i ++){
            GR [l] = gr;
            PART [l] = part;
            int br = round (part * k);
            for (int j = 0; j < k; j ++){
                if (j < br) p [l][j] = gr * 2 + 1;
                else p [l][j] = gr * 2;
            }
            part += step;
            l ++;
        }
    }
    /*cout << '\n';
    for (auto v : p){
        for (int i : v) cout << i << ' ';
        cout << '\n';
    }*/
    return p;
}

int guessPlaylist (){
    int q = min (K, (int) round (N / (S / 2) * 1.2));
    int gr, cnt;
    int x = nextSong ();
    gr = x / 2;
    cnt = x % 2;
    for (int i = 1; i < q; i ++){
        cnt += nextSong () % 2;
    }
    double part = (double) cnt / q;
    for (int i = 0; i < N; i ++){
        if (GR [i] == gr && PART [i] >= part){
            if (i == 0 || GR [i - 1] != gr || PART [i] - part < part - PART [i - 1]) return i;
            else return i - 1;
        }
        if (GR [i] > gr) return i - 1;
    }
    return N - 1;
}
