#include <bits/stdc++.h>
#include "playlists.h"
using namespace std;

int N, K, S;
double P;
int GR [128];
double PART [128];
int sol2;
pair <int, int> pairs [128];
pair <pair <int, int>, int> triples [128];

vector <vector <int> > makePlaylists (int n, int k, int s, double pp){
    N = n;
    K = k;
    S = s;
    P = pp;
    vector <vector <int> > p (n, vector <int> (k, 0));

    if (K > 1 && S * (S - 1) / 2 >= N){
        sol2 = 2;
        int l = 0;
        for (int i = 0; i < s; i ++){
            if (l == N) break;
            for (int j = i + 1; j < s; j ++){
                if (l == N) break;
                for (int x = 0; x < K / 2; x ++) p [l][x] = i;
                for (int x = K / 2; x < K; x ++) p [l][x] = j;
                pairs [l] = {i, j};
                l ++;
            }
        }
        return p;
    }
    if (K > 3 && S * (S - 1) * (S - 2) / 6 >= N){
        sol2 = 3;
        int l = 0;
        for (int i = 0; i < s; i ++){
            if (l == N) break;
            for (int j = i + 1; j < s; j ++){
                if (l == N) break;
                for (int h = j + 1; h < s; h ++){
                    if (l == N) break;
                    for (int x = 0; x < K / 3; x ++) p [l][x] = i;
                    for (int x = K / 3; x < 2 * K / 3; x ++) p [l][x] = j;
                    for (int x = 2 * K / 3; x < K; x ++) p [l][x] = h;
                    triples [l] = {{i, j}, h};
                    l ++;
                }
            }
        }
        return p;
    }

    S -= S % 2;
    int x = N / (S / 2), r = N % (S / 2);
    int l = 0;
    for (int gr = 0; gr < S / 2; gr ++){
        int cnt = (gr < r ? x + 1 : x);
        double step = 1.0 / (cnt - 1), part = 0;
        for (int i = 0; i < cnt; i ++){
            GR [l] = gr;
            PART [l] = part;
            int br = round (part * k);
            for (int j = 0; j < k; j ++){
                if (j < br) p [l][j] = gr * 2 + 1;
                else p [l][j] = gr * 2;
            }
            part += step;
            l ++;
        }
    }
    /*cout << '\n';
    for (auto v : p){
        for (int i : v) cout << i << ' ';
        cout << '\n';
    }*/
    return p;
}

int guessPlaylist (){

    if (sol2 == 2){
        int x = nextSong (), y = x;
        while (y == x) y = nextSong ();
        if (x > y) swap (x, y);
        for (int i = 0; i < N; i ++) if (pairs [i] == make_pair (x, y)) return i;
        return 0;
    }
    if (sol2 == 3){
        int x = nextSong (), y = x, z = x;
        while (y == x) y = nextSong ();
        while (z == x || z == y) z = nextSong ();
        if (x > y) swap (x, y);
        if (x > z) swap (x, z);
        if (y > z) swap (y, z);
        for (int i = 0; i < N; i ++) if (triples [i] == make_pair (make_pair (x, y), z)) return i;
        return 0;
    }

    int q = min (K, (int) round (N / (double) (S / 2) * 2 * P));
    int gr, cnt;
    int x = nextSong ();
    gr = x / 2;
    cnt = x % 2;
    for (int i = 1; i < q; i ++){
        cnt += nextSong () % 2;
    }
    double part = (double) cnt / q;
    for (int i = 0; i < N; i ++){
        if (GR [i] == gr && PART [i] >= part){
            if (i == 0 || GR [i - 1] != gr || PART [i] - part < part - PART [i - 1]) return i;
            else return i - 1;
        }
        if (GR [i] > gr) return i - 1;
    }
    return N - 1;
}
