#include<iostream>
#include<vector>
#include<algorithm>
#include<queue>
#include<map>
using namespace std;
short pairs[10000][10000];
short otk[10000];
vector<int>nesusedi[10005];
map<pair<int,int>,int>done;
int path[100000];
int n,m;
int bfs(int from, int to){
    for(int i=0;i<10000;i++){
        path[i]=-1;
    }
    path[from]=0;
    queue<int>curr;
    curr.push(from);
    while(!curr.empty()){
        int c=curr.front();
        curr.pop();
        if(c==to){
            return path[c];
        }
        for(int i=0;i<n;i++){
            if(pairs[c][i]==0 && path[i]==-1){
                path[i]=path[c]+1;
                curr.push(i);
            }
        }
    }
    return -1;
}
int main(){

    cin>>n>>m;
    for(int i=0;i<m;i++){
        int a,b;
        cin>>a>>b;
        otk[a]++;
        otk[b]++;
        nesusedi[a].push_back(b);
        nesusedi[b].push_back(a);
        pairs[a][b]=1;
        pairs[b][a]=1;
    }
    for(int i=0;i<n;i++){
        for(int j=0;j<nesusedi[i].size();j++){
            for(int k=j+1;k<nesusedi[i].size();k++){
                if(pairs[nesusedi[i][j]][nesusedi[i][k]]!=0 && pairs[nesusedi[i][k]][nesusedi[i][j]]!=0){
                    pairs[nesusedi[i][j]][nesusedi[i][k]]++;
                    pairs[nesusedi[i][k]][nesusedi[i][j]]++;
                }
            }
        }
    }
    int q;
    cin>>q;
    for(int i=0;i<q;i++){
        int a,b;
        cin>>a>>b;
        if(b<a)swap(a,b);
        if(a==b){
            cout<<0<<endl;
            continue;
        }
        if(pairs[a][b]==0){
            cout<<1<<endl;
            continue;
        }
        //cout<<"test: "<<otk[a]+otk[b]-pairs[a][b]-1<<" "<<pairs[a][b]<<endl;
        if(otk[a]+otk[b]-pairs[a][b]-1!=n-2){
            cout<<2<<endl;
            continue;
        }
        if(done[{a,b}]!=0){
            cout<<done[{a,b}]<<endl;
        }else{
            int ans=bfs(a,b);
            cout<<ans<<endl;
            done[{a,b}]=ans;
        }
    }
    return 0;
}
