#include<iostream>
#include<vector>
#include<map>
#include "playlists.h"
using namespace std;
vector<vector<int> >m_playlists;
int gn,gk,gs;
double gp;
map<pair<int,int>,int> inds;
int state=0;
vector<vector<int> > makePlaylists(int n, int k, int s, double p){
    gn=n;
    gs=s;
    gk=k;
    gp=p;
    if(s>=n){
        state=1;

        for(int i=0;i<n;i++){
            vector<int>playlist;
            for(int j=0;j<k;j++){
                playlist.push_back(i);
            }
            m_playlists.push_back(playlist);
        }
        return m_playlists;
    }
    if(s*(s-1)/2>=n){
        state=2;
        vector<int>playlist;
        for(int i=0;i<s;i++){
            for(int j=i+1;j<s;j++){
                playlist.clear();
                for(int c=0;c<k;c++){
                    if(c<k/2){
                        playlist.push_back(i);
                    }else{
                        playlist.push_back(j);
                    }
                }
                inds[{i,j}]=m_playlists.size();
                m_playlists.push_back(playlist);
                if(m_playlists.size()==n){
                    return m_playlists;
                }
            }
        }
    }
    return m_playlists;
}
double total=0;
int guessPlaylist(){
    if(state==1){
        if(total>20000.0*gp){
            //cout<<20000.0*gp<<endl;
            total++;
            return 0;
        }
        int first=nextSong();
        total++;
        return first;
    }
    if(state==2){
        if(total>20000.0*gp){
            //cout<<20000.0*gp<<endl;
            total++;
            return 0;
        }
        int first=nextSong();
        int second=first;
        while(second==first){
            second=nextSong();
        }
        if(first>second)swap(first,second);
        //cout<<first<<" "<<second<<endl;
        total++;
        return inds[{first,second}];
    }
}
