#include<iostream>
#include<vector>
#include<utility>
#include<queue>
using namespace std;

const int Max_N=10010;

int n,m,q;
vector<int> graph[Max_N];

vector< pair<int,int> > que;

// from - to

bool adj_mat [Max_N][Max_N];
int dist [Max_N][Max_N];

void init_adj_mat(){
    for(int i=0;i<n;i++){
        for(int j=0;j<n;j++){
            adj_mat[i][j]=true;
        }
    }
}

void calc_graph(){
    for(int i=0;i<n;i++){
        for(int j=0;j<n;j++){
            if(adj_mat[i][j]){
                graph[i].push_back(j);
            }
        }
    }
}

void init_dist(){
    for(int i=0;i<n;i++){
        for(int j=0;j<n;j++){
            dist[i][j]=-1;
        }
    }
    return;
}

void bfs(int st){
    dist[st][st]=0;
    queue<int> quem;
    quem.push(st);
    int curr;
    while(!quem.empty()){
        curr=quem.front();
        quem.pop();
        for(int i=0;i<graph[curr].size();i++){
            if(dist[st][graph[curr][i]]==-1){
                dist[st][graph[curr][i]]=dist[st][curr]+1;
                quem.push(graph[curr][i]);
            }
        }
    }
    return;
}

void calc_all(){
    for(int i=0;i<n;i++){
        bfs(i);
    }
    return;
}

void answer_queries(){
    for(int i=0;i<q;i++){
        cout<<dist[que[i].first][que[i].second]<<endl;
    }
    return;
}

int main(){
    ios_base::sync_with_stdio(false);
    cin>>n>>m;
    int a,b;
    init_adj_mat();
    for(int i=0;i<m;i++){
        cin>>a>>b;
        adj_mat[a][b]=false;
        adj_mat[b][a]=false;
    }
    calc_graph();
    cin>>q;
    que.resize(q);
    for(int i=0;i<q;i++){
        cin>>a>>b;
        que[i].first=a;
        que[i].second=b;
    }
    init_dist();
    calc_all();
//    for(int i=0;i<n;i++){
//        for(int j=0;j<n;j++){
//            cout<<dist[j][i];
//        }
//        cout<<endl;
//    }
    answer_queries();
    return 0;
}
