#include<iostream>
#include<vector>
#include<utility>
#include<queue>
using namespace std;

const int Max_N=10000;

int n,m,q;
vector< vector<bool> > adj_mat;
int dist [Max_N][Max_N];

vector< pair<int,int> > que;

void init_adj_mat(){
    adj_mat.resize(n);
    for(int i=0;i<n;i++){
        adj_mat[i].resize(n);
    }
    for(int i=0;i<n;i++){
        for(int j=0;j<n;j++){
            adj_mat[i][j]=true;
            if(i==j){
                dist[i][j]=0;
            }else{
                dist[i][j]=1;
            }
        }
    }
    return;
}

int k=1;
queue < pair<int,int> > unfound;
queue < pair<int,int> > to_add;

void calc(){
    int queue_size,big_counter=0;
    bool was_an_update;
    pair< int,int > curr;
    while(!unfound.empty()){
        if(big_counter==n){
            return;
        }
        big_counter++;
        k++;
        queue_size=unfound.size();
        for(int i=0;i<queue_size;i++){
            curr=unfound.front();
            unfound.pop();

            for(int j=0;j<n;j++){
                if(adj_mat[j][curr.second] and adj_mat[curr.first][j]){
                    to_add.push(curr);
                    goto end_calc_for;
                }
            }
            unfound.push(curr);
            end_calc_for:;

        }

        while(!to_add.empty()){
            was_an_update=true;
            curr=to_add.front();
            to_add.pop();
            adj_mat[curr.first][curr.second]=true;
            adj_mat[curr.second][curr.first]=true;
            dist[curr.first][curr.second]=k;
            dist[curr.second][curr.first]=k;
        }

    }
    return;
}

void answer_queries(){
    int curr_res;
    for(int i=0;i<q;i++){
        curr_res=dist[que[i].first][que[i].second];
        cout<<curr_res<<endl;
    }
    return;
}

int main(){
    ios_base::sync_with_stdio(false);
    cin>>n>>m;
    int a,b;
    init_adj_mat();
    for(int i=0;i<m;i++){
        cin>>a>>b;
        if(adj_mat[a][b]){
            adj_mat[a][b]=false;
            adj_mat[b][a]=false;
            dist[a][b]=-1;
            dist[b][a]=-1;
            unfound.push({a,b});
        }
    }
    cin>>q;
    que.resize(q);
    for(int i=0;i<q;i++){
        cin>>a>>b;
        que[i].first=a;
        que[i].second=b;
    }
    calc();
//    for(int i=0;i<n;i++){
//        for(int j=0;j<n;j++){
//            cout<<dist[i][j]<<" ";
//        }
//        cout<<endl;
//    }
    answer_queries();
    return 0;
}
