#include<iostream>
using namespace std;

const int Max_L = 55;

const int Max_N=125100;

struct coord{

    int x,y,z;

};

int n,res;
coord arr [Max_N];

int num_inf=0;
bool inf [Max_L][Max_L];

void add_extra_inf(){
    for(int i=1;i<Max_L-1;i++){
        for(int j=1;j<Max_L-1;j++){
            if(!inf[i][j]){
                if(inf[i+1][j] and inf[i-1][j] and inf[i][j+1] and inf[i][j-1]){
                    inf[i][j]=true;
                    num_inf++;
                }
            }
        }
    }
    return;
}

int num_walls=0;

void calc_num_walls(){
    for(int i=0;i<Max_L;i++){
        for(int j=0;j<Max_L;j++){

            if(!inf[i][j]){
                goto end_counting_walls_for;
            }

            if(i!=0){
                if(!inf[i-1][j]){
                    num_walls++;
                }
            }else{
                num_walls++;
            }

            if(i!=(Max_L-1)){
                if(!inf[i+1][j]){
                    num_walls++;
                }
            }else{
                num_walls++;
            }

            if(j!=0){
                if(!inf[i][j-1]){
                    num_walls++;
                }
            }else{
                num_walls++;
            }

            if(j!=(Max_L-1)){
                if(!inf[i][j+1]){
                    num_walls++;
                }
            }else{
                num_walls++;
            }

            end_counting_walls_for:;

        }
    }
    return;
}

void calc_res(){
    res=2*num_inf+num_walls;
    return;
}

int main(){
    ios_base::sync_with_stdio(false);
    cin>>n;
    for(int i=0;i<n;i++){
        cin>>arr[i].x>>arr[i].y>>arr[i].z;
        inf [arr[i].x][arr[i].y ] = true;
        num_inf++;
    }
    add_extra_inf();
    calc_num_walls();
    calc_res();
    cout<<res;
    return 0;
}
