#include<iostream>
#include<utility>
using namespace std;

const int Max_L = 55;

const int Max_N=125100;

struct coord{

    int x,y,z;

};

int n,res;
coord arr [Max_N];

int num_inf=0;
bool inf [Max_L][Max_L];

int num_cc=0;
int area_cc,out_walls,inf_walls;

bool vis [Max_L][Max_L];
int cc [Max_L][Max_L];

void dfs(int curr_i,int curr_j){
    vis[curr_i][curr_j]=true;
    cc[curr_i][curr_j]=num_cc;
    area_cc++;

    if(curr_i!=0){
        if(!inf[curr_i-1][curr_j]){
            if(!vis[curr_i-1][curr_j]){
                dfs(curr_i-1,curr_j);
            }
        }else{
            inf_walls++;
        }
    }else{
        out_walls++;
    }

    if(curr_i!=(Max_L-1)){
        if(!inf[curr_i+1][curr_j]){
            if(!vis[curr_i+1][curr_j]){
                dfs(curr_i+1,curr_j);
            }
        }else{
            inf_walls++;
        }
    }else{
        out_walls++;
    }

    if(curr_j!=0){
        if(!inf[curr_i][curr_j-1]){
            if(!vis[curr_i][curr_j-1]){
                dfs(curr_i,curr_j-1);
            }
        }else{
            inf_walls++;
        }
    }else{
        out_walls++;
    }

    if(curr_j!=(Max_L-1)){
        if(!inf[curr_i][curr_j+1]){
            if(!vis[curr_i][curr_j+1]){
                dfs(curr_i,curr_j+1);
            }
        }else{
            inf_walls++;
        }
    }else{
        out_walls++;
    }

    return;
}

void find_connected_comp(){
    for(int i=0;i<Max_L;i++){
        for(int j=0;j<Max_L;j++){

            if(!inf[i][j] and !vis[i][j]){
                area_cc=0;
                out_walls=0;
                inf_walls=0;

                dfs(i,j);

                if( (2*area_cc + out_walls)<inf_walls ){

                    for(int ii=0;ii<Max_L;ii++){
                        for(int jj=0;jj<Max_L;jj++){
                            if(cc[ii][jj]==num_cc){
                                inf[ii][jj]=true;
                                num_inf++;
                            }
                        }
                    }

                }

                num_cc++;

            }

        }
    }
    return;
}

int num_walls=0;

void calc_num_walls(){
    for(int i=0;i<Max_L;i++){
        for(int j=0;j<Max_L;j++){

            if(!inf[i][j]){
                goto end_counting_walls_for;
            }

            if(i!=0){
                if(!inf[i-1][j]){
                    num_walls++;
                }
            }else{
                num_walls++;
            }

            if(i!=(Max_L-1)){
                if(!inf[i+1][j]){
                    num_walls++;
                }
            }else{
                num_walls++;
            }

            if(j!=0){
                if(!inf[i][j-1]){
                    num_walls++;
                }
            }else{
                num_walls++;
            }

            if(j!=(Max_L-1)){
                if(!inf[i][j+1]){
                    num_walls++;
                }
            }else{
                num_walls++;
            }

            end_counting_walls_for:;

        }
    }
    return;
}

void calc_res(){
    res=2*num_inf+num_walls;
    return;
}

int main(){
    ios_base::sync_with_stdio(false);
    cin>>n;
    for(int i=0;i<n;i++){
        cin>>arr[i].x>>arr[i].y>>arr[i].z;
        inf [arr[i].x][arr[i].y ] = true;
        num_inf++;
    }
    find_connected_comp();
    calc_num_walls();
    calc_res();
    cout<<res;
    return 0;
}
