#include<bits/stdc++.h>
using namespace std;
vector<vector<vector<bool>>> infected(50, vector<vector<bool>>(50, vector<bool>(50, false)));
vector<vector<vector<bool>>> twin(50, vector<vector<bool>>(50, vector<bool>(50, false)));
bool isInfected(int x, int y, int z)
{
    if(x < 0 || x > 49 || y < 0 || y > 49 || z < 0 || z > 49)
    {
        return false;
    }
    return infected[x][y][z];
}
bool isTwin(int x, int y, int z)
{
    if(x < 0 || x > 49 || y < 0 || y > 49 || z < 0 || z > 49)
    {
        return false;
    }
    return twin[x][y][z];
}

int countInfectedNeighbors(int x, int y, int z)
{
    return isInfected(x, y, z + 1) +
           isInfected(x, y, z - 1) +
           isInfected(x, y + 1, z) +
           isInfected(x, y - 1, z) +
           isInfected(x + 1, y, z) +
           isInfected(x - 1, y, z);
}
int countTwinNeighbors(int x, int y, int z)
{
    return isTwin(x, y, z + 1) +
           isTwin(x, y, z - 1) +
           isTwin(x, y + 1, z) +
           isTwin(x, y - 1, z) +
           isTwin(x + 1, y, z) +
           isTwin(x - 1, y, z);
}

int main()
{
    int n;
    cin>>n;
    int x,y,z;

    for(int i = 0; i < n; i++)
    {
        cin>>x>>y>>z;
        infected[x][y][z] = true;
    }
    bool first = true;
    bool wasThereAchange = true;
    while(wasThereAchange)
    {
        wasThereAchange = false;
        for(int i = 0; i < 50; i++)
        {
            for(int j = 0; j < 50; j++)
            {
                for(int w = 0; w < 50; w++)
                {
                    if(isInfected(i,j,w))
                    {
                        continue;
                    }
                    int cnt = countInfectedNeighbors(i,j,w);
                    if(cnt >= 3)
                    {
                        infected[i][j][w] = true;
                        twin[i][j][w] = false;
                        wasThereAchange = true;
                    }
                    else if(cnt == 2) {
                        twin[i][j][w] = true;
                    }

                    if(countTwinNeighbors(i,j,w) + countInfectedNeighbors(i,j,w) >= 4) {
                        infected[i][j][w] = true;
                        twin[i][j][w] = false;
                        wasThereAchange = true;
                    }
                }
            }
        }
        if(!wasThereAchange && first) {
            first = false;
            wasThereAchange = true;
        }
    }
    int res = 0;
    for(int i = 0; i < 50; i++)
    {
        for(int j = 0; j < 50; j++)
        {
            for(int w = 0; w < 50; w++)
            {
                if(infected[i][j][w])
                {
                    res += 6 - countInfectedNeighbors(i, j, w);
                }
            }
        }
    }
    cout<<res<<endl;
}
