#include <bits/stdc++.h>
using namespace std;

int const MAXN=2600;
int m, n;
int a[MAXN][MAXN];
vector<int> v[MAXN];
int used[MAXN][MAXN];

void BFS(int i)
{
    used[i][i]=1;
    queue<int> q;
    q.push(i);
    while(!q.empty())
    {
        int w=q.front();
        q.pop();
        int sz=v[w].size();
        for(int j=0;j<sz;j++)
        {
            if(!used[i][v[w][j]])
            {
                q.push(v[w][j]);
                used[i][v[w][j]]=used[i][w]+1;
            }
        }
    }
}

void read()
{
    int x, y, q;
    cin>>n>>m;
    for(int i=1;i<=m;i++)
    {
        cin>>x>>y;
        if(x>y) swap(x,y);
        a[x][y]=1;
    }
    for(int i=0;i<n-1;i++)
    {
        for(int j=i+1;j<n;j++)
        {
            if(a[i][j]==0)
            {
                v[i].push_back(j);
                v[j].push_back(i);
            }
        }
    }
    for(int i=0;i<n;i++)
    {
        BFS(i);
    }
    cin>>q;
    for(int i=1;i<=q;i++)
    {
        cin>>x>>y;
        cout<<used[x][y]-1<<"\n";
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    read();
    return 0;
}
