#include<bits/stdc++.h>

using namespace std;

int const maxn = 10002;

int n,m,q;
int a[maxn][maxn];

void read()
{
    int i,x,y;
    cin>>n>>m;

    for(i=0; i<m; i++)
    {
        cin>>x>>y;
        a[x][y] = true;
        a[y][x] = true;
    }
}

bool used[maxn];
int BFS(int x,int y)
{
    int i;
    queue<pair<int,int> >q;
    q.push({x,0});

    memset(used,0,sizeof(used));
    used[x] = true;

    while(!q.empty())
    {
        pair<int,int> p = q.front();
        q.pop();

        if(p.first == y)return p.second;

        for(i=0; i<n; i++)
        {
            if(used[i] || a[p.first][i])continue;

            used[i] = true;
            q.push({i,p.second+1});
        }
    }

    return -1;
}

void queries()
{
    int i,x,y;

    cin>>q;

    for(i=0; i<q; i++)
    {
        cin>>x>>y;
        cout<<BFS(x,y)<<"\n";
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    read();
    queries();
    return 0;
}
