#include<bits/stdc++.h>

using namespace std;

int const maxn = 10002;

int n,m,q;
int a[maxn][maxn];

void read()
{
    int i,x,y;
    cin>>n>>m;

    for(i=0; i<m; i++)
    {
        cin>>x>>y;
        a[x][y] = true;
        a[y][x] = true;
    }
}

int used[maxn][maxn];
int BFS(int x,int y)
{
    int i;
    queue<pair<int,int> >q;

    if(x == y) return 0;
    if(!a[x][y])
        used[x][y] = used[y][x] = 1;

    if(used[x][y]) return used[x][y];

    q.push({x,0});

    while(!q.empty())
    {
        pair<int,int> p = q.front();
        q.pop();

        if(p.first == y)return p.second;

        for(i=0; i<n; i++)
        {
            if(a[p.first][i] || used[i][p.first])continue;

            int t = p.first;
            used[i][t] = used[t][i] = 1;
            if(!used[x][i])used[x][i] = used[i][x] = p.second + 1;
            else used[x][i] = min(used[i][x],used[i][x] = p.second + 1);

            if(used[i][y])
            {
                if(!used[x][y])
                    used[x][y] = used[y][x] = used[i][x] + used[i][y];
                else
                    used[x][y] = used[y][x] = min(used[x][y],used[i][x] + used[i][y]);
            }

            q.push({i,p.second+1});
        }
    }

    if(!used[x][y])
        return -1;

    return used[x][y];
}

void queries()
{
    int i,x,y;

    cin>>q;

    for(i=0; i<q; i++)
    {
        cin>>x>>y;
        cout<<BFS(x,y)<<"\n";
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    read();
    queries();
    return 0;
}
