#include<bits/stdc++.h>
#include "playlists.h"
using namespace std;

int lamp,sz;
int global_s,global_k;

vector<vector<int> >v;
map<vector<int>, int>mp;
vector<int>tv;

void combinations(int i,int last)
{
    if(i == global_k)
    {
        mp[tv] = v.size();
        v.push_back(tv);
        return;
    }

    int j;
    for(j=last; j<global_s; j++)
    {
        tv[i] = j;
        combinations(i+1,j);
    }
}

int cnt;
bool check(int i,int last,int range)
{
    if(i == global_k || cnt >= range)
    {
        cnt++;
        return true;
    }

    int j;
    for(j=last; j<global_s; j++)
    {
        if(cnt >= range)return true;
        check(i+1,j,range);
    }
    return true;
}

std::vector<std::vector<int> > makePlaylists(int n, int k, int s, double p)
{
    vector<vector<int> >ans;
    vector<int> t;

    global_s = s;
    global_k = k;

    int i=0,j,num = 0;
    while(num < s && i<n && check(0,num+1,n-i) && cnt >= n-i)
    {
        t.clear();
        lamp = i;

        for(j=0; j<k; j++)
            t.push_back(num);

        ans.push_back(t);
        num++; i++;
    }
    if(i >= n)
        return ans;

    tv.resize(k);
    combinations(0,num);
    sz = i;

    for(i=i; i<n; i++)
        ans.push_back(v[i-sz]);

    return ans;
}

bool cmp(int a,int b)
{
    return a<b;
}

int guessPlaylist()
{
    int song = nextSong();

    if(song <= lamp)
        return song;

    vector<int>t;
    t.push_back(song);

    int i;
    for(i=1; i<global_k; i++)
    {
        song = nextSong();
        t.push_back(song);
    }

    sort(t.begin(),t.end(),cmp);

    return mp[t] - sz;
}
