#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

struct Room {
    int x;
    int y;
    int z;

    Room(int x, int y, int z) {
        this->x = x;
        this->y = y;
        this->z = z;
    }
};

void setIO() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int n;
vector<Room> rooms;

void read() {
    cin >> n;

    rooms.reserve(n);
    for (int i = 0; i < n; i++) {
        int x, y, z;
        cin >> x >> y >> z;

        rooms.emplace_back(x, y, z);
    }
}

void solve() {
    int answer = 6 * n;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            int diff = rooms[j].x - rooms[i].x + 1;
            int len = j - i + 1;
            int newAnswer = 4 * diff + 6 * (n - len);
            if (newAnswer < answer) {
                answer = newAnswer;
            }
        }
    }

    cout << answer << endl;
}

int main() {
    setIO();

    read();

    solve();
}
