# include <bits/stdc++.h>
//#pragma GCC optimize ("O3")
//#pragma GCC target ("sse4")
using namespace std;
const int maxn = 1e4+5;
const int maxtask = 1e6+5;
int n,m;
vector <int> g[maxn];
vector <pair <int,int> > task[maxn];
int tasks[maxn];
int ans[maxtask];
struct node
{
    int prev;
    int next;
    int id;
};
set <pair <int,int> > st;
node p[maxn];
int groups[maxn];
void restore()
{
    int i;
    for(i=1;i<=n;i++)
    {
        p[i].id = i;
        p[i].prev = i-1;
        p[i].next = i+1;
    }
    p[0].next = 1;
    p[0].prev = -1;

    p[n].next = -1;
}
void del(int v)
{
    int prev=  p[v].prev;
    int next = p[v].next;
    if(prev!=-1)
        p[prev].next = next;
    if(next!=-1)
        p[next].prev = prev;
}
int dist[maxn];
int vis[maxn],visid;
 queue <pair <int,int> > q;
 void dfs(int v, int s)
 {
   //  cout<<v<<"->"<<s<<endl;
     groups[v] = s;
     del(v);
     queue <int> q;
q.push(v);
     int i=0;
     while(!q.empty())
     {
         v = q.front();
         q.pop();
       //  cout<<v<<"->"<<s<<endl;
         groups[v] = s;
         int  u = p[0].next;
         i=0;
         while(u!=-1)
         {
              while(i<g[v].size()&&g[v][i]<u)i++;
            if(i<g[v].size()&&u==g[v][i])
            {
                u = p[u].next;
                continue;
            }
            q.push(u);

            int next = p[u].next;
            del(u);
            u = next;
         }

            //cout<<"go from "<<v<<" "<<u<<endl;

     }
 }
void bfs(int t)
{
    //cout<<t<<" :"<<endl;
    visid++;
while(!q.empty())q.pop();
    q.push({t,0});
    del(t);
    vis[t] = visid;
    dist[t] = 0;
    int v,u,d;
    int i;

    while(tasks[t]&&!q.empty())
    {
        v = q.front().first;
        d = q.front().second;

        q.pop();
       // cout<<v<<" "<<d<<endl;
        u = p[0].next;
        i = 0;
        while(u!=-1)
        {
         //   cout<<"Check "<<u<<endl;
            while(i<g[v].size()&&g[v][i]<u)i++;
            if(i<g[v].size()&&u==g[v][i])
            {
                u = p[u].next;
                continue;
            }
            vis[u] = visid;
            dist[u] = d+1;
            if(st.find({t,u})!=st.end())
                {
                    st.erase({t,u});
                    st.erase({u,t});
                    tasks[t]--;
                }
         //  cout<<v<<"->"<<u<<" "<<d+1<<endl;
            q.push({u,d+1});
            int prev = u;
            u  = p[u].next;
            del(prev);
        }
    }
    for(i=0;i<task[t].size();i++)
    {
        v = task[t][i].first;
        int id = task[t][i].second;
       // cout<<"TASK"<<v<<" "<<id<<" "<<dist[v]<<endl;
        if(vis[v]!=visid)ans[id] = -1;
        else
            ans[id] = dist[v];
        tasks[v]--;
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cin>>n>>m;
    int i,j;
    int u,v;
    for(i=1;i<=m;i++)
    {
        cin>>u>>v;
        u++;
        v++;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    restore();
    for(i=1;i<=n;i++)
        sort(g[i].begin(),g[i].end());
        for(i=1;i<=n;i++)
        {
            if(groups[i]==0)dfs(i,i);
            //cout<<i<<" "<<groups[i]<<endl;
        }
    int q;
    cin>>q;
    for(i=1;i<=q;i++)
    {
        cin>>u>>v;
        u++;
        v++;
        if(groups[u]!=groups[v])
        {
            ans[i] = -1;
            continue;
        }
        tasks[u]++;
        tasks[v]++;

        task[u].push_back({v,i});
        task[v].push_back({u,i});
        st.insert({u,v});
        st.insert({v,u});
    }
  // return 0;
    for(i=1;i<=n;i++)
    {
        if(tasks[i]==0)continue;
        restore();
        bfs(i);
    }
    for(i=1;i<=q;i++)
        cout<<ans[i]<<endl;

    return 0;
}
