#include<bits/stdc++.h>
using namespace std;

using num = short;

const num maxN = 1e4;
num n, m;

vector<vector<num> > g;
vector<vector<num> > ans;
bitset<maxN> visited;

void read()
{
    vector<set<num> > missing;
    cin >>n >>m;
    missing.resize(n);
    g.resize(n);
    ans.assign(n, vector<num>(n, -2));

    num a, b;
    for(int i = 0; i < m; i++)
    {
        cin >>a >>b;
        missing[a].insert(b);
        missing[b].insert(a);
    }

    num cc;
    for(int i = 0; i < n; i++)
    {
        cc = 0;
        for(num m : missing[i])
        {
            while(cc != m && cc < n)
            {
                if(cc == i)
                {
                    cc++;
                    continue;
                }
                g[i].emplace_back(cc++);
            }
            cc++;
        }
    }
    /*
    for(int i = 0; i < n; i++)
    {
        cout <<i <<" -> ";
        for(int j : g[i])
        {
            cout <<j <<" ";
        }cout <<endl;
    }
    //*/
}

num bfs(num s, num e)
{
    visited = 0;
    ans[s].assign(n, -1);
    queue<num> q;
    visited[s] = 1;
    ans[s][s] = 0;
    q.push(s);
    while(!q.empty())
    {
        num v = q.back();
        q.pop();
        for(num next : g[v])
        {
            //cout <<"hh " <<next <<" len ";
            if(!visited[next])
            {
                visited[next] = 1;
                ans[s][next] = ans[next][s] = ans[s][v] + 1;
                q.push(next);
            }
            //cout <<len[next] <<endl;
            if(next == e) return ans[s][e];
        }
    }

    return ans[s][e];
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    read();

    int q;
    cin >>q;
    num a, b;
    while(q--)
    {
        cin >>a >>b;
        if(a == b)
        {
            cout <<0 <<endl;
            continue;
        }
        cout <<(ans[a][b] == -2 ? bfs(a, b) : ans[a][b]) <<endl;
    }
}
