#include<bits/stdc++.h>
using namespace std;

#define prnt(p) cout <<#p <<" " <<(char)(p.x + '0') <<" " <<(char)(p.y + '0') <<" " <<(char)(p.z + '0') <<endl;

int n;
//*
struct room
{
    char x, y, z;
};
//*/
const char maxi = 50;

bitset<maxi> hosp[maxi][maxi];
bitset<maxi> vis[maxi][maxi];
int ans = 0;

char countFreeWalls(char x, char y, char z)
{
    int free = 0;
    free += (x > 0 && !hosp[x - 1][y][z]) || x == 0;
    free += (y > 0 && !hosp[x][y - 1][z]) || y == 0;
    //free += (z > 0 && !hosp[x][y][z - 1]) || z == 0;
    free += (x < maxi && !hosp[x + 1][y][z]) || x == maxi;
    free += (y < maxi && !hosp[x][y + 1][z]) || y == maxi;
    //free += (z < maxi && !hosp[x][y][z + 1]) || z == maxi;
    return free;
}

room xxx;
vector<room> getFreeNeib(char x, char y, char z)
{
    vector<room> free;
    if(x > 0 && hosp[x - 1][y][z]) free.emplace_back(xxx = { x - 1, y, z });
    if(y > 0 && hosp[x][y - 1][z]) free.emplace_back(xxx = { x, y - 1, z });
    //if(z > 0 && hosp[x][y][z - 1]) free.emplace_back(xxx = { x, y, z - 1 });
    if(x < maxi && hosp[x + 1][y][z]) free.emplace_back(xxx = { x + 1, y, z });
    if(y < maxi && hosp[x][y + 1][z]) free.emplace_back(xxx = { x, y + 1, z });
    //if(z < maxi && hosp[x][y][z + 1]) free.emplace_back(xxx = { x, y, z + 1 });
    return free;
}

void bfs(room start)
{
    vis[start.x][start.y][start.z] = 1;
    queue<room> q;
    q.push(start);
    while(!q.empty())
    {
        room v = q.back();
        ans += countFreeWalls(v.x, v.y, v.z);
        q.pop();
        for(room next : getFreeNeib(v.x, v.y, v.z))
        {
            if(!vis[next.x][next.y][next.z])
            {
                vis[next.x][next.y][next.z] = true;
                q.push(next);
            }
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    cin >>n;
    room lower = {CHAR_MAX, CHAR_MAX, CHAR_MAX}, upper = {CHAR_MIN, CHAR_MIN, CHAR_MIN};
    short x, y, z;
    for(int i = 0; i < n; i++)
    {
        cin >>x >>y >>z;
        hosp[x][y][z] = 1;
        lower.x = min(lower.x, (char)x);
        lower.y = min(lower.y, (char)y);
        lower.z = min(lower.z, (char)z);

        upper.x = max(upper.x, (char)x);
        upper.y = max(upper.y, (char)y);
        upper.z = max(upper.z, (char)z);
    }

    //prnt(lower);
    //prnt(upper);

    for(char i = lower.x; i <= upper.x; i++)
    {
        for(char j = lower.y; j <= upper.y; j++)
        {
            for(char k = lower.z; k <= upper.z; k++)
            {
                if(hosp[i][j][k] && !vis[i][j][k]) bfs(xxx = { i, j, k });
                //cout <<(char)(i + '0') <<" " <<(char)(j + '0') <<" " <<(char)(z + '0') <<" " <<ans <<endl;
            }
        }
    }
    //*
    for(char i = lower.x; i <= upper.x; i++)
    {
        for(char j = lower.y; j <= upper.y; j++)
        {
            for(char k = lower.z; k <= upper.z; k++)
            {
                if(!hosp[i][j][k])
                {
                    char free = countFreeWalls(i, j, k);
                    //if(free < 3) ans += 2 * free - 6;
                    if(free < 2) ans += 2 * free - 4;
                }
            }
        }
    }
    int
        dx = upper.x - lower.x + 1,
        dy = upper.y - lower.y + 1,
        dz = upper.z - lower.z + 1;
    int maximum = 2 * (dx * dy + dy * dz + dz * dx);
    //*/
    cout <<min(ans, maximum) <<endl;
}
/*
8
0 0 0
0 0 1
0 0 2
0 1 0
0 1 2
0 2 0
0 2 1
0 2 2

30
*/
