#include<bits/stdc++.h>
using namespace std;

#define prnt(p) cout <<#p <<" " <<(char)(p.x + '0') <<" " <<(char)(p.y + '0') <<" " <<(char)(p.z + '0') <<endl;
#define pr(v) cout <<#v <<" " <<v <<" ";
#define nl() cout <<endl;

int n;
//*
struct room
{
    char x, y, z;
};
//*/
const char maxi = 50;

struct walls
{
    bool
        top = false,
        btm = false,
        frnt = false,
        bck = false,
        left = false,
        right = false;
};

bitset<maxi> hosp[maxi][maxi];
bitset<maxi> vis[maxi][maxi];
bitset<maxi> vis2[maxi][maxi];
bitset<maxi> inv[maxi][maxi];
walls w[maxi][maxi][maxi];
room
    lower = {CHAR_MAX, CHAR_MAX, CHAR_MAX},
    upper = {CHAR_MIN, CHAR_MIN, CHAR_MIN};
int ans = 0;

char countFreeWalls(char x, char y, char z)
{
    int free = 0;
    free += (x > 0 && !hosp[x - 1][y][z]) || x == 0;
    free += (y > 0 && !hosp[x][y - 1][z]) || y == 0;
    free += (z > 0 && !hosp[x][y][z - 1]) || z == 0;
    free += (x < maxi && !hosp[x + 1][y][z]) || x == maxi;
    free += (y < maxi && !hosp[x][y + 1][z]) || y == maxi;
    free += (z < maxi && !hosp[x][y][z + 1]) || z == maxi;
    return free;
}

room xxx;
vector<room> getFreeNeib(char x, char y, char z)
{
    vector<room> free;
    if(x > 0 && hosp[x - 1][y][z]) free.emplace_back(xxx = { x - 1, y, z });
    if(y > 0 && hosp[x][y - 1][z]) free.emplace_back(xxx = { x, y - 1, z });
    if(z > 0 && hosp[x][y][z - 1]) free.emplace_back(xxx = { x, y, z - 1 });
    if(x < maxi && hosp[x + 1][y][z]) free.emplace_back(xxx = { x + 1, y, z });
    if(y < maxi && hosp[x][y + 1][z]) free.emplace_back(xxx = { x, y + 1, z });
    if(z < maxi && hosp[x][y][z + 1]) free.emplace_back(xxx = { x, y, z + 1 });
    return free;
}

void bfs(room start)
{
    vis[start.x][start.y][start.z] = 1;
    queue<room> q;
    q.push(start);
    while(!q.empty())
    {
        room v = q.back();
        ans += countFreeWalls(v.x, v.y, v.z);
        q.pop();
        for(room next : getFreeNeib(v.x, v.y, v.z))
        {
            if(!vis[next.x][next.y][next.z])
            {
                vis[next.x][next.y][next.z] = true;
                q.push(next);
            }
        }
    }
}
vector<room> getFreeCleanNeib(char x, char y, char z)
{
    vector<room> free;
    if(x > 0 && !hosp[x - 1][y][z]) free.emplace_back(xxx = { x - 1, y, z });
    if(y > 0 && !hosp[x][y - 1][z]) free.emplace_back(xxx = { x, y - 1, z });
    if(z > 0 && !hosp[x][y][z - 1]) free.emplace_back(xxx = { x, y, z - 1 });
    if(x < maxi && !hosp[x + 1][y][z]) free.emplace_back(xxx = { x + 1, y, z });
    if(y < maxi && !hosp[x][y + 1][z]) free.emplace_back(xxx = { x, y + 1, z });
    if(z < maxi && !hosp[x][y][z + 1]) free.emplace_back(xxx = { x, y, z + 1 });
    return free;
}
void bfsClean(room start)
{
    vis2[start.x][start.y][start.z] = 1;
    queue<room> q;
    q.push(start);
    while(!q.empty())
    {
        room v = q.back();
        q.pop();
        for(room next : getFreeCleanNeib(v.x, v.y, v.z))
        {
            if(!vis2[next.x][next.y][next.z])
            {
                if(inv[next.x][next.y][next.z])
                {
                    if(!w[next.x][next.y][next.z].top)
                    {
                        if(next.z < maxi && inv[next.x][next.y][next.z + 1])
                        {
                            w[next.x][next.y][next.z].top = w[next.x][next.y][next.z + 1].btm = true;
                            //pr("top"); pr(inv[next.x][next.y][next.z + 1]); prnt(v);
                            ans -= 2;
                        }
                    }
                    if(!w[next.x][next.y][next.z].btm)
                    {
                        if(next.z > 0 && inv[next.x][next.y][next.z - 1])
                        {
                            w[next.x][next.y][next.z].btm = w[next.x][next.y][next.z - 1].top = true;
                            //pr("btm"); prnt(v);
                            ans -= 2;
                        }
                    }
                    if(!w[next.x][next.y][next.z].left)
                    {
                        if(next.x > 0 && inv[next.x - 1][next.y][next.z])
                        {
                            w[next.x][next.y][next.z].left = w[next.x - 1][next.y][next.z].right = true;
                            //pr("left"); pr(inv[next.x - 1][next.y][next.z]); prnt(v);
                            ans -= 2;
                        }
                    }
                    if(!w[next.x][next.y][next.z].right)
                    {
                        if(next.x < maxi && inv[next.x + 1][next.y][next.z])
                        {
                            w[next.x][next.y][next.z].right = w[next.x + 1][next.y][next.z].left = true;
                            //pr("right"); prnt(v);
                            ans -= 2;
                        }
                    }
                    if(!w[next.x][next.y][next.z].frnt)
                    {
                        if(next.y > 0 && inv[next.x][next.y - 1][next.z])
                        {
                            w[next.x][next.y][next.z].frnt = w[next.x][next.y - 1][next.z].bck = true;
                            //pr("frnt"); prnt(v);
                            ans -= 2;
                        }
                    }
                    if(!w[next.x][next.y][next.z].bck)
                    {
                        if(next.y < maxi && inv[next.x][next.y + 1][next.z])
                        {
                            w[next.x][next.y][next.z].bck = w[next.x][next.y + 1][next.z].frnt = true;
                            //pr("bck"); prnt(v);
                            ans -= 2;
                        }
                    }
                }

                vis2[next.x][next.y][next.z] = true;
                q.push(next);
            }
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    cin >>n;
    short x, y, z;
    for(int i = 0; i < n; i++)
    {
        cin >>x >>y >>z;
        hosp[x][y][z] = 1;
        lower.x = min(lower.x, (char)x);
        lower.y = min(lower.y, (char)y);
        lower.z = min(lower.z, (char)z);

        upper.x = max(upper.x, (char)x);
        upper.y = max(upper.y, (char)y);
        upper.z = max(upper.z, (char)z);
    }

    //prnt(lower);
    //prnt(upper);

    for(char i = lower.x; i <= upper.x; i++)
    {
        for(char j = lower.y; j <= upper.y; j++)
        {
            for(char k = lower.z; k <= upper.z; k++)
            {
                if(hosp[i][j][k] && !vis[i][j][k]) bfs(xxx = { i, j, k });
                //cout <<(char)(i + '0') <<" " <<(char)(j + '0') <<" " <<(char)(z + '0') <<" " <<ans <<endl;

            }
        }
    }
    //*
    for(char i = lower.x; i <= upper.x; i++)
    {
        for(char j = lower.y; j <= upper.y; j++)
        {
            for(char k = lower.z; k <= upper.z; k++)
            {
                if(!hosp[i][j][k])
                {
                    char free = countFreeWalls(i, j, k);
                    if(free < 3)
                    {
                        ans += 2 * free - 6;
                        inv[i][j][k] = 1;
                    }
                }
            }
        }
    }
    for(char i = lower.x; i <= upper.x; i++)
    {
        for(char j = lower.y; j <= upper.y; j++)
        {
            for(char k = lower.z; k <= upper.z; k++)
            {
                if(!hosp[i][j][k] && !vis2[i][j][k])
                {
                    bfsClean(xxx = { i, j, k });
                }
            }
        }
    }
    //*/
    int
        dx = upper.x - lower.x + 1,
        dy = upper.y - lower.y + 1,
        dz = upper.z - lower.z + 1;
    int maximum = 2 * (dx * dy + dy * dz + dz * dx);
    cout <<min(ans, maximum) <<endl;
}
/*
8
0 0 0
0 0 1
0 0 2
0 1 0
0 1 2
0 2 0
0 2 1
0 2 2

30

10
0 0 0
0 0 1
0 0 2
0 0 3
0 1 0
0 1 3
0 2 0
0 2 1
0 2 2
0 2 3

38
*/
