#include "playlists.h"

int kk, nn, ss;

std::vector<std::vector<int>> makePlaylists(int n, int k, int s, double p){
    std::vector<std::vector<int>> playlist;
    kk = k;  nn = n;  ss = s;
    int i;
    for(i=0;i<s;i++){
        std::vector<int> pl;
        for(int j=1;j<=k;j++){
            pl.push_back(i);
        }
        playlist.push_back(pl);
    }
    for(i=s;i<n;i++){
        std::vector<int> pl;
        int in = i%s;
        for(int j=1;j<=k/2;j++){
            pl.push_back(in);
        }
        for(int j=k/2+1;j<=k;j++){
            pl.push_back(s-1-in);
        }
        playlist.push_back(pl);
    }
    //std::cout<<playlist.size()<<"\n";
    return playlist;
}

int guessPlaylist(){
    int p=-1, q=-1;
    p = nextSong();
    int tek;
    for(int i=1;i<=kk/2;i++){
           // std::cout<<i<<" ";
        tek = nextSong();
        if(tek != p) {q=tek;  break; }
    }
    if(q == -1) return p;
    else
        return nn-ss+p;
}
