#include<cstdio>
#include<cstring>
#include<unordered_set>
#include<queue>
using namespace std;
#define MAXN 10000
int F[MAXN][MAXN];
unordered_set<int> G[MAXN];
unordered_set<int>::iterator it;
int i,j;
int n,k;
int t;
void bfs(int v)
{
	queue<int> q;
	bool used[MAXN];
	q.push(v);
	memset(used,false,sizeof(used));
	used[v]=true;
	k=0;
	F[v][v]=0;
	while(q.size())
	{
		n=q.size();
		k++;
		while(n--)
		{
			t=q.front();
			q.pop();
			for(it=G[t].begin();it!=G[t].end();it++)
				if(!used[*it])
				{
					used[*it]=true;
					F[v][*it]=k;
					q.push(*it);
				}
		}
				
	}
}
int main()
{
	int N,M;
	int a,b;
	scanf("%d %d",&N,&M);
	memset(F,-1,N*N);
	for(i=0;i<N;i++)
		for(j=0;j<N;j++)
			if(i!=j)
				G[i].insert(j);
	for(i=0;i<M;i++)
	{
		scanf("%d %d",&a,&b);
		G[a].erase(b);
		G[b].erase(a);
	}
	
	for(j=0;j<N;j++)
		bfs(j);
	int Q;
	scanf("%d",&Q);
	for(i=0;i<Q;i++)
	{
		scanf("%d %d",&a,&b);
		printf("%d\n",F[a][b]);
	}
}
