#include<bits/stdc++.h>
#define f first
#define s second
#define pb push_back
#define eb emplace_back

#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse4")
#pragma GCC target("avx2")

using namespace std;

const int MAXN = 1e4 + 100;
int n, m;
list<int> ncon[MAXN];
bitset<MAXN> con[MAXN];
map<int, int> ans[MAXN];

void input() {
    cin>>n>>m;

    for (int i=0; i<n; i++) {
        con[i] = ~con[i];
    }

    int a, b;
    for (int i=0; i<m; i++) {
        cin>>a>>b;
        ncon[a].pb(b);
        con[a][b] = 0;
        ncon[b].pb(a);
        con[b][a] = 0;
    }
}

void calcFor(int curr) {
    int cnt = 2;
    bitset<MAXN> temp = con[curr];
    bitset<MAXN> temp2;
    bool ch = 1;
    while (ch) {
        ch = 0;
        temp2 = 0;
        for (auto tod = ncon[curr].begin(); tod != ncon[curr].end();) {
            int to = *tod;
            int id = (con[to]&temp)._Find_first();
            if (id < n) {
                temp2[to] = 1;
                ch = 1;
                ans[curr][to] = cnt;
                auto tod2 = tod;
                tod++;
                ncon[curr].erase(tod2);
            } else {
                tod++;
            }
        }
        temp = temp2;
        cnt++;
    }
    for (auto to : ncon[curr]) {
        ans[curr][to] = -1;
    }
}

void solve() {
    for (int i=0; i<n; i++) {
        calcFor(i);
    }

    int q;
    int a, b;
    cin>>q;
    while(q--) {
        cin>>a>>b;
        if (a == b) {
            cout<<0<<'\n';
        } else if (ans[a].find(b) == ans[a].end()) {
            cout<<1<<'\n';
        } else {
            cout<<ans[a][b]<<'\n';
        }
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    input();
    solve();
    return 0;
}

