#include<bits/stdc++.h>
#define f first
#define s second
#define pb push_back
#define eb emplace_back

#include "playlists.h"

using namespace std;

const int MAXN = 100 + 5;
int n, k, s;
double p;
int num;
vector<vector<int>> pl;
int wh[MAXN][MAXN];

vector<vector<int>> makePlaylists(int N, int K, int S, double P) {
    srand(time(NULL));
    n = N, k = K, s = S, p = P;
    pl.resize(n);

    int calc = 1;
    int curr = 0;
    for (num = 1; num <= s; num++) {
        calc = calc*(s-num+1) / num;

        vector<int> p(num);
        for (int i=0; i<num; i++) {
            p[i] = i;
        }

        for (int i=0; i<calc; i++) {
            if (curr == n) {
                break;
            }

            pl[curr].resize(k);
            for (int z=0; z<k; z++) {
                pl[curr][z] = p[z%num];
            }

            for (int z=num-1; z>=0; z--) {
                p[z]++;
                if (p[z]+num-1-z < s) {
                    for (z = z+1; z<num; z++) {
                        p[z] = p[z-1]+1;
                    }
                    break;
                }
            }
            curr++;
        }
        if (curr == n) {
            break;
        }
    }

    for (curr; curr < n; curr++) {
        pl[curr].resize(k);
        for (int i=0; i<k; i++) {
            pl[curr][i] = rand()%s;
        }
    }

    for (int i=0; i<pl.size(); i++) {
        for (int j=0; j<pl[i].size(); j++) {
            wh[pl[i][j]][i]++;
        }
    }

    for (int i=0; i<pl.size(); i++) {
        cerr<<i<<" - ";
        for (int j=0; j<pl[i].size(); j++) {
            cerr<<pl[i][j]<<' ';
        }
        cerr<<endl;
    }
    cerr<<"done"<<endl;

    return pl;
}

int guessPlaylist() {
    list<int> cs;
    for (int i=0; i<n; i++) {
        cs.pb(i);
    }

    int to = min((int)ceil((double)1.7*num), k);
    int ct = 10 + num/5;
    set<int> usedCol;
    int ch = 0;
    vector<int> cnt(s);
    while (ch < min(to, ct)) {
        int curr = nextSong();
        cnt[curr]++;
        usedCol.insert(curr);
        ct = 4*(usedCol.size()+num/6);

        //cerr<<123<<endl;
        auto id = cs.begin();
        while (id != cs.end()) {
            auto id2 = id++;
            if (wh[curr][*id2] < cnt[curr]) {
                cs.erase(id2);
            }
        }
        if ((double)1 / cs.size() >= p) {
            //cerr<<*cs.begin()<<endl;
            return *cs.begin();
        }
        ch++;
    }
    return *cs.begin();
}
/*
16 4 4 0.5
*/
