#include <bits/stdc++.h>
#pragma GCC optimize("O3")

using namespace std;
typedef long long ll;
template<class T> void check_min(T &a, const T &b){ a = (a < b) ? a : b; }
template<class T> void check_max(T &a, const T &b){ a = (a > b) ? a : b; }
#define all(x) (x).begin(), (x).end()
int get_int();
ll get_ll();

const int N = 1e4 + 3;
const int Q = 1e6 + 3;

int n, m, q, ans[Q], d[N];
bool e[N][N];
vector<pair<int, int>> quer[N];

void bfs(int start){
    vector<int> not_vis;
    queue<int> q;

    for(int i = 0; i < n; ++i)
        if(i != start)
            not_vis.push_back(i);
    q.push(start);
    fill(d, d + n, -1);
    d[start] = 0;

    vector<int> new_not_vis;
    while(!q.empty() && !not_vis.empty()){
        int u = q.front();
        q.pop();

        new_not_vis.clear();
        for(int to: not_vis){
            if(!e[u][to]){
                q.push(to);
                d[to] = d[u] + 1;
            }
            else new_not_vis.push_back(to);
        }
        swap(new_not_vis, not_vis);
    }

    for(auto [to, idx]: quer[start])
        ans[idx] = d[to];
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    n = get_int(), m = get_int();
    for(int i = 0; i < m; ++i){
        int a = get_int(), b = get_int();
        e[a][b] = true;
        e[b][a] = true;
    }

    q = get_int();
    for(int i = 0; i < q; ++i){
        int c = get_int(), d = get_int();
        if(quer[c].size() < quer[d].size()) swap(c, d);
        quer[c].push_back({d, i});
    }

    for(int i = 0; i < n; ++i){
        if(quer[i].empty()) continue;
        bfs(i);
    }

    for(int i = 0; i < q; ++i)
        cout << ans[i] << "\n";
}

int ptr = Q - 1;
char buff[Q];

void next_char(){ if(++ptr == Q) fread(buff, 1, Q, stdin), ptr = 0; }

int get_int(){
    int ret = 0;
    for(; buff[ptr] < '0' || '9' < buff[ptr]; next_char());
    for(; '0' <= buff[ptr] && buff[ptr] <= '9'; next_char())
        ret = 10 * ret + buff[ptr] - '0';
    return ret;
}

ll get_ll(){
    ll ret = 0;
    for(; buff[ptr] < '0' || '9' < buff[ptr]; next_char());
    for(; '0' <= buff[ptr] && buff[ptr] <= '9'; next_char())
        ret = 10 * ret + buff[ptr] - '0';
    return ret;
}
