#include <bits/stdc++.h>
#include "playlists.h"

using namespace std;
typedef long long ll;
template<class T> void check_min(T &a, const T &b){ a = (a < b) ? a : b; }
template<class T> void check_max(T &a, const T &b){ a = (a > b) ? a : b; }
#define all(x) (x).begin(), (x).end()
int get_int();
ll get_ll();

int nextSong();
const int N = 100 + 3;

mt19937 mt(133);
vector<vector<int>> ans;
vector<vector<int>> t;

int f[N][N];
int n, k, s;
double p;

vector<vector<int>> makePlaylists(int _n, int _k, int _s, double _p){
    n = _n, k = _k, s = _s, p = _p;
    if(n == s){
        for(int i = 0; i < n; ++i){
            ans.push_back({});
            for(int j = 0; j < k; ++j)
                ans.back().push_back(i);
        }
        return ans;
    }

    int i = 0;
    vector<int> v;
    /*for(; i < s && i < n; ++i){
        v.clear();
        for(int j = 0; j < k; ++j)
            v.push_back(i);
        ans.push_back(v);
        for(int j = 0; j < k; ++j)
            f[i][v[j]]++;
    }*/

    vector<vector<int>> perm;
    for(int i1 = 0; i1 < s; ++i1){
        for(int i2 = i1; i2 < s; ++i2){
            perm.push_back({});
            for(int j = 0; j < k / 2; ++j)
                perm.back().push_back(i1);
            for(int j = k / 2; j < k; ++j)
                perm.back().push_back(i2);
        }
    }
    random_shuffle(all(perm), [&](int mod){
            return mt() % mod;
        });

    for(auto &v: perm){
        if(i == n) break;
        ans.push_back(v);
        for(int j = 0; j < k; ++j)
            f[i][v[j]]++;
        ++i;
    }
    return ans;
}

double cnt_win = 0, cnt_p = 0;

int guessPlaylist(){
    if(n == 1) return 0;
    if(n == s){
        return nextSong();
    }

    static int f2[N];
    fill(f2, f2 + s, 0);
    for(int i = 0; i < k; ++i){
        ++f2[nextSong()];
        int cnt = 0, ret = -1;
        for(int j = 0; j < n; ++j){
            bool ok = true;
            for(int j2 = 0; j2 < s; ++j2)
            if(f[j][j2] < f2[j2]){
                ok = false;
                break;
            }
            if(ok){
                ++cnt;
                ret = j;
            }
        }

        if(i == k - 1 || cnt == 1){
            return ret;
        }
    }
    return 0;
}

