#include <iostream>
#include <algorithm>
#include <vector>
#include <queue>
using namespace std;
#define endl '\n'
const int MAXN=3e3+10;
const int MAXQ=1e6+10;
struct Query {
    int a, b, ind;
};
Query p[MAXQ];
vector <int> v[MAXN];
queue <int> q;
int dist[MAXN][MAXN], ans[MAXQ];
bool matr[MAXN][MAXN];
bool cmp(Query a, Query b) {
    return a.a<b.a;
}
void bfs(int start) {
    q.push(start);
    dist[start][start]=0;
    int x;
    while (!q.empty()) {
        x=q.front();
        q.pop();
        for (auto i:v[x]) {
            if (dist[start][i]!=-1) continue;
            dist[start][i]=dist[start][x]+1;
            q.push(i);
        }
    }
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m, a, b;
    cin >> n >> m;
    for (int i=0;i<m;i++) {
        cin >> a >> b;
        matr[a][b]=matr[b][a]=true;
    }
    for (int i=0;i<n;i++) {
        for (int j=i+1;j<n;j++) {
            if (matr[i][j]) continue;
            v[i].push_back(j);
            v[j].push_back(i);
        }
    }
    int quer;
    cin >> quer;
    for (int i=0;i<quer;i++) {
        cin >> p[i].a >> p[i].b;
        if (p[i].a>p[i].b) swap(a,b);
        p[i].ind=i;
    }
    sort(p,p+quer,cmp);
    int last=-1;
    for (int i=0;i<quer;i++) {
        if (p[i].a!=last) {
            for (int j=0;j<n;j++) dist[p[i].a][j]=-1;
            bfs(p[i].a);
            last=p[i].a;
        }
        ans[p[i].ind]=dist[p[i].a][p[i].b];
    }
    for (int i=0;i<quer;i++) cout << ans[i] << endl;
    return 0;
}
