#include <iostream>
#include <unordered_map>
#include <set>
#include <vector>
#include <random>
#include "playlists.h"
using namespace std;
const long long mod=1e9+7;
const int sys=101;
long long h[128][128], st[128];
unordered_map <long long, int> cnt, sr;
int n1, k1;
vector <vector <int> > makePlaylists(int n, int k, int s, double p) {
    vector <vector<int> > res;
    vector <int> a;
    n1=n; k1=k;
    int br;
    st[0]=1;
    for (int i=1;i<k;i++) st[i]=(st[i-1]*sys);
    long long curh;
    for (int i=0;i<n;i++) {
        if (!a.empty()) a.clear();
        int ss=k;
        int j=0;
        while (ss>0) {
            int times=rand()%ss;
            if (ss==1) times=1;
            ss-=times;
            for (int l=0;l<times;l++) a.push_back(j%s);
            j++;
        }
        h[i][0]=a[0];
        cnt[h[i][0]]++;
        sr[h[i][0]]=i;
        for (int j=1;j<k;j++) {
            h[i][j]=(h[i][j-1]*sys+a[j])%mod;
            cnt[h[i][j]]++;
            sr[h[i][j]]=i;
            for (int l=1;l<=j;l++) {
                curh=(h[i][j]-(h[i][l-1]*st[j-l])%mod+mod)%mod;
                cnt[curh]++;
                sr[curh]=i;
            }
        }
        res.push_back(a);
    }
    return res;
}
int guessPlaylist() {
    if (n1==1) return 0;
    int ans=-1, el;
    long long curh;
    set <int> cur;
    for (int i=0;i<k1;i++) {
        el=nextSong();
        cur.insert(el);
        curh=0;
        for (auto it=cur.begin();it!=cur.end();it++) curh=(curh*sys+(*it))%mod;
        if (cnt[curh]==1) {
            ans=sr[curh];
            break;
        }
    }
    if (ans==-1) ans=sr[curh];
    return ans;
}
