#include <iostream>
using namespace std;
int matr[64][64][64], comp[64][64][64];
int mov[6][3]={{1,0,0},{0,1,0},{-1,0,0},{0,-1,0},{0,0,1},{0,0,-1}};
int maxx, maxy, maxz;
void dfs(int i, int j, int l, int br) {
    comp[i][j][l]=br;
    int x, y, z;
    for (int k=0;k<6;k++) {
        x=i+mov[k][0];
        y=j+mov[k][1];
        z=l+mov[k][2];
        if (x<0 || y<0 || z<0 || x>maxx || y>maxy || z>maxz || !matr[x][y][z] || comp[x][y][z]) continue;
        dfs(x,y,z,br);
    }
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, x, y, z;
    cin >> n;
    for (int i=0;i<n;i++) {
        cin >> x >> y >> z;
        matr[x][y][z]=true;
        maxx=max(x,maxx);
        maxy=max(y,maxy);
        maxz=max(z,maxz);
    }
    int cnt, pr=(maxx+1)*(maxy+1)*(maxz+1);
    for (int times=0;times<pr;times++) {
        for (int i=0;i<=maxx;i++) {
            for (int j=0;j<=maxy;j++) {
                for (int l=0;l<=maxz;l++) {
                    if (matr[i][j][l]) continue;
                    cnt=0;
                    for (int k=0;k<6;k++) {
                        x=i+mov[k][0];
                        y=j+mov[k][1];
                        z=l+mov[k][2];
                        if (x<0 || y<0 || z<0 || x>maxx || y>maxy || z>maxz) continue;
                        if (matr[x][y][z]) cnt++;
                    }
                    if (cnt>=3) matr[i][j][l]=true;
                }
            }
        }
    }
    int br=1;
    cnt=0;
    for (int i=0;i<=maxx;i++) {
        for (int j=0;j<=maxy;j++) {
            for (int l=0;l<=maxz;l++) {
                if (!matr[i][j][l]) continue;
                cnt++;
                if (!comp[i][j][l]) {
                    dfs(i,j,l,br);
                    br++;
                }
            }
        }
    }
    int ans=cnt*6;
    for (int i=0;i<=maxx;i++) {
        for (int j=0;j<=maxy;j++) {
            for (int l=0;l<=maxz;l++) {
                if (comp[i][j][l]==0) continue;
                for (int k=0;k<6;k++) {
                    x=i+mov[k][0];
                    y=j+mov[k][1];
                    z=l+mov[k][2];
                    if (x<0 || y<0 || z<0 || x>maxx || y>maxy || z>maxz) continue;
                    if (comp[x][y][z]==comp[i][j][l]) ans--;
                }
            }
        }
    }
    cout << ans << endl;
    return 0;
}
/**
8
0 2 0
1 1 0
2 0 0
3 1 0
4 2 0
3 3 0
2 4 0
1 3 0
**/

