#include <vector>

int nextSong();
std::vector<std::vector<int>> makePlaylists(int n, int k, int s, double p);
int guessPlaylist();

#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
template<class T, class T2> bool chkmax(T &a, const T2 &b) {return (a < b) ? a = b, 1 : 0;}
template<class T, class T2> bool chkmin(T &a, const T2 &b) {return (a > b) ? a = b, 1 : 0;}

namespace a {
int n, k, s;
double p;
};

vector<vector<int> > makePlaylists(int _n, int _k, int _s, double _p) {
    a::n = _n;
    a::k = _k;
    a::s = _s;
    a::p = _p;
    vector<vector<int> > ret;
    if((1 << a::s) > a::n) {
        for(int i = 1; i <= a::n; i ++) {
            vector<int> now;
            for(int j = 0; j < min(32, a::s); j ++) {
                if(i & (1 << j)) {
                    now.push_back(j);
                }
            }
            int szBeg = now.size();
            for(int j = szBeg; j < a::k; j ++) {
                now.push_back(now[j % szBeg]);
            }
            ret.push_back(now);
        }
    } else {
        for(int i = 0; i < a::n; i ++) {
            vector<int> now;
            int lft = i;
            for(int j = 0; j < a::k; j ++) {
                now.push_back(min(lft, a::s - 1));
                lft -= min(lft, a::s - 1);
            }
            ret.push_back(now);
        }
    }
    return ret;
}

int guessPlaylist() {
    int ans = 0;
    if((1 << a::s) > a::n) {
        for(int i = 0; i < a::k - 1; i ++) {
            ans |= (1 << nextSong());
        }
        return ans - 1;
    } else {
        for(int i = 0; i < a::k; i ++) {
            ans += nextSong();
        }
        return ans;
    }
}
