#include <bits/stdc++.h>
using namespace std;
#define endl "\n"
typedef long long ll;
template<class T, class T2> bool chkmax(T &a, const T2 &b) {return (a < b) ? a = b, 1 : 0;}
template<class T, class T2> bool chkmin(T &a, const T2 &b) {return (a > b) ? a = b, 1 : 0;}

const int MAX_N = 1e5 + 10;

struct Cube {
    pair<int, int> x, y, z;
    Cube() {}
    Cube(int _x, int _y, int _z) {
        x = {_x, _x + 1};
        y = {_y, _y + 1};
        z = {_z, _z + 1};
    }
    Cube(const pair<int, int> &_x, const pair<int, int> &_y, const pair<int, int> &_z) {
        x = _x;
        y = _y;
        z = _z;
    }
};

Cube merge(const Cube &a, const Cube &b) {
    return {{min(a.x.first, b.x.first), max(a.x.second, b.x.second)}, {min(a.y.first, b.y.first), max(a.y.second, b.y.second)}, {min(a.z.first, b.z.first), max(a.z.second, b.z.second)}};
}

int val(const Cube &a) {
    return 2 * ((a.x.second - a.x.first) * (a.y.second - a.y.first) + (a.x.second - a.x.first) * (a.z.second - a.z.first) + (a.z.second - a.z.first) * (a.y.second - a.y.first));
}

void print(const Cube &a) {
    cout << a.x.first << " " << a.x.second << " " << a.y.first << " " << a.y.second << " " << a.z.first << " " << a.z.second << endl;
}

Cube arr[MAX_N];
bool on[MAX_N];
int n;

signed main() {
    int sec = 0;
    cin >> n;
    for(int i = 0; i < n; i ++) {
        int x, y, z;
        on[i] = true;
        cin >> x >> y >> z;
        arr[i] = Cube(x, y, z);
    }
    while(true) {
        bool flag = false;
        for(int i = 0; i < n; i ++) if(on[i]) {
            for(int j = i + 1; j < n; j ++) if(on[j]) {
                print(arr[i]);
                print(arr[j]);
                print(merge(arr[i], arr[j]));
                if(val(arr[i]) + val(arr[j]) >= val(merge(arr[i], arr[j]))) {
                    arr[i] = merge(arr[i], arr[j]);
                    on[j] = false;
                    flag = true;
                }
            }
        }
        if(!flag) {
            break;
        }
    }
    int ans = 0;
    for(int i = 0; i < n; i ++) {
        if(on[i]) {
            ans += val(arr[i]);
        }
    }
    cout << ans << endl;
    return 0;
}
