#include <bits/stdc++.h>
using namespace std;
#define endl "\n"
typedef long long ll;
template<class T, class T2> bool chkmax(T &a, const T2 &b) {return (a < b) ? a = b, 1 : 0;}
template<class T, class T2> bool chkmin(T &a, const T2 &b) {return (a > b) ? a = b, 1 : 0;}

const int MAX_N = 150;
int comp[MAX_N][MAX_N];
int n;

void dfs(int i, int j) {
    if(comp[i + 1][j] == -1) {comp[i + 1][j] = comp[i][j]; dfs(i + 1, j);}
    if(comp[i - 1][j] == -1) {comp[i - 1][j] = comp[i][j]; dfs(i - 1, j);}
    if(comp[i][j + 1] == -1) {comp[i][j + 1] = comp[i][j]; dfs(i, j + 1);}
    if(comp[i][j - 1] == -1) {comp[i][j - 1] = comp[i][j]; dfs(i, j - 1);}
}

signed main() {
    cin >> n;
    for(int i = 0; i < n; i ++) {
        int x, y, z;
        cin >> x >> y >> z;
        comp[x + 2][y + 2] = -1;
    }
    int cnt = 1;
    for(int i = 0; i < MAX_N; i ++) {
        for(int j = 0; j < MAX_N; j ++) {
            if(comp[i][j] == -1) {
                comp[i][j] = cnt ++;
                dfs(i, j);
            }
        }
    }
    int ans = 0;
    for(int i = 1; i < MAX_N - 1; i ++) {
        for(int j = 1; j < MAX_N - 1; j ++) {
            if(comp[i][j] != 0) {
                ans += 2;
            } else {
                int nowCnt = 0;
                if(comp[i - 1][j] != 0) {nowCnt ++;}
                if(comp[i + 1][j] != 0) {nowCnt ++;}
                if(comp[i][j - 1] != 0) {nowCnt ++;}
                if(comp[i][j + 1] != 0) {nowCnt ++;}
                if(nowCnt >= 3) {
                    ans += 6 - nowCnt;
                } else {
                    ans += nowCnt;
                }
            }
        }
    }
    cout << ans << endl;
    return 0;
}

