#include <iostream>
#include <vector>
using namespace std;

const int inf = 987654321;

int n, m, q;
int a, b;

vector<vector<int> > sys;

int main(){

    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);

    cin >> n >> m;
    sys.resize(n, vector<int>(n));

    for(int i = 0; i < n; i++){
        for(int j = 0; j < n; j++){
            if(i != j) sys[i][j] = 1;
            else sys[i][j] = 0;
        }
    }

    for(int i = 0; i < m; i++){
        cin >> a >> b;
        sys[a][b] = inf;
        sys[b][a] = inf;
    }

    /*for(int i = 0; i < n; i++){
        for(int j = 0; j < n; j++){
            cout << sys[i][j] << " ";
        }
        cout << endl;
    }*/

    for(int i = 0; i < n; i++){
        for(int j = 0; j < n; j++){
            for(int k = 0; k < n; k++){
                if(i != j && i != k && j != k && sys[i][k]+sys[k][j] < sys[i][j]){
                    sys[i][j] = sys[i][k]+sys[k][j];
                    sys[j][i] = sys[i][k]+sys[k][j];
                }
            }
        }
    }
    for(int i = 0; i < n; i++){
        for(int j = 0; j < n; j++){
            for(int k = 0; k < n; k++){
                if(i != j && i != k && j != k && sys[i][k]+sys[k][j] < sys[i][j]){
                    sys[i][j] = sys[i][k]+sys[k][j];
                    sys[j][i] = sys[i][k]+sys[k][j];
                }
            }
        }
    }

    cin >> q;
    for(int i = 0; i < q; i++){
        cin >> a >> b;
        if(sys[a][b] < inf) cout << sys[a][b] << endl;
        else cout << -1 << endl;
    }

return 0;
}
