#include <iostream>
#include <vector>
using namespace std;

const int MAXN = 17;

int n;
int x, y, z;
int tk[64][64][64];
int tkn;

int ans;

struct tripl
{
    int first;
    int second;
    int third;
};

vector<tripl> offset;

void marktk()
{
    for(int i = 1; i <= MAXN; i++){
        for(int j = 1; j <= MAXN; j++){
            for(int k = 1; k <= MAXN; k++){
                if(tk[i][j][k] == 0){
                    int c = 0;
                    for(auto h: offset){
                        c += tk[i+h.first][j+h.second][k+h.third];
                    }
                    if(c >= 3){
                        tk[i][j][k] = 1;
                        tkn++;
                    }
                }
            }
        }
    }
}

int main(){

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    offset = {{-1, 0, 0}, {1, 0, 0}, {0, 1, 0}, {0, -1, 0}, {0, 0, -1}, {0, 0, 1}};

    cin >> n;
    tkn = n;
    for(int i = 0; i < n; i++){
        cin >> x >> y >> z;
        x++;
        y++;
        z++;
        tk[x][y][z] = 1;
    }

    for(int i = 0; i < 3*MAXN + 1; i++){
        marktk();
    }


    for(int i = 1; i <= MAXN; i++){
        for(int j = 1; j <= MAXN; j++){
            for(int k = 1; k <= MAXN; k++){
                if(tk[i][j][k] == 1){
                    int c = 0;
                    for(auto h: offset){
                        c += 1-tk[i+h.first][j+h.second][k+h.third];
                    }
                    ans += c;
                }
            }
        }
    }

    cout << ans << endl;

return 0;
}
