#include <bits/stdc++.h>
using namespace std;

int n;
bool b [64][64][64];
bool b1 [64][64][64];
bool b2 [64][64][64];

struct room{
    int x, y, z;
};

int bfs2 (int X, int Y, int Z){
    for (int x = 1; x <= 15; x ++){
        for (int y = 1; y <= 15; y ++){
            for (int z = 1; z <= 15; z ++){
                b2 [x][y][z] = b1 [x][y][z];
            }
        }
    }
    b2 [X][Y][Z] = 1;
    int res = -2;
    queue <room> q;
    q.push ({X - 1, Y, Z});
    q.push ({X + 1, Y, Z});
    q.push ({X, Y - 1, Z});
    q.push ({X, Y + 1, Z});
    q.push ({X, Y, Z - 1});
    q.push ({X, Y, Z + 1});
    while (!q.empty ()){
        room r = q.front ();
        q.pop ();
        if (b2 [r.x][r.y][r.z] || r.x == 0 || r.x > 15 || r.y == 0 || r.y > 15 || r.z == 0 || r.z > 15) continue;
        int x = r.x, y = r.y, z = r.z, cnt = 0;
        if (b2 [x - 1][y][z]) cnt ++;
        if (b2 [x + 1][y][z]) cnt ++;
        if (b2 [x][y - 1][z]) cnt ++;
        if (b2 [x][y + 1][z]) cnt ++;
        if (b2 [x][y][z - 1]) cnt ++;
        if (b2 [x][y][z + 1]) cnt ++;
        if (cnt >= 3){
            res += 2 * cnt - 6;
            b2 [x][y][z] = 1;
            q.push ({x - 1, y, z});
            q.push ({x + 1, y, z});
            q.push ({x, y - 1, z});
            q.push ({x, y + 1, z});
            q.push ({x, y, z - 1});
            q.push ({x, y, z + 1});
        }
    }
    if (res >= 0){
        for (int x = 1; x <= 15; x ++){
            for (int y = 1; y <= 15; y ++){
                for (int z = 1; z <= 15; z ++){
                    b1 [x][y][z] = b2 [x][y][z];
                }
            }
        }
        return res;
    }
    return -1;
}

int bfs (int X, int Y, int Z){
    for (int x = 1; x <= 15; x ++){
        for (int y = 1; y <= 15; y ++){
            for (int z = 1; z <= 15; z ++){
                b1 [x][y][z] = b [x][y][z];
            }
        }
    }
    b1 [X][Y][Z] = 1;
    int res = -2;
    queue <room> q;
    q.push ({X - 1, Y, Z});
    q.push ({X + 1, Y, Z});
    q.push ({X, Y - 1, Z});
    q.push ({X, Y + 1, Z});
    q.push ({X, Y, Z - 1});
    q.push ({X, Y, Z + 1});
    while (!q.empty ()){
        room r = q.front ();
        q.pop ();
        if (b1 [r.x][r.y][r.z] || r.x == 0 || r.x > 15 || r.y == 0 || r.y > 15 || r.z == 0 || r.z > 15) continue;
        int x = r.x, y = r.y, z = r.z, cnt = 0;
        if (b1 [x - 1][y][z]) cnt ++;
        if (b1 [x + 1][y][z]) cnt ++;
        if (b1 [x][y - 1][z]) cnt ++;
        if (b1 [x][y + 1][z]) cnt ++;
        if (b1 [x][y][z - 1]) cnt ++;
        if (b1 [x][y][z + 1]) cnt ++;
        if (cnt >= 3){
            res += 2 * cnt - 6;
            b1 [x][y][z] = 1;
            q.push ({x - 1, y, z});
            q.push ({x + 1, y, z});
            q.push ({x, y - 1, z});
            q.push ({x, y + 1, z});
            q.push ({x, y, z - 1});
            q.push ({x, y, z + 1});
        }
    }

    for (int i = 0; i < 5000; i ++){
        bool flag = 0;
        for (int x = 1; x <= 15; x ++){
            for (int y = 1; y <= 15; y ++){
                for (int z = 1; z <= 15; z ++){
                    if (b1 [x][y][z]) continue;
                    int cnt = 0;
                    if (b1 [x - 1][y][z]) cnt ++;
                    if (b1 [x + 1][y][z]) cnt ++;
                    if (b1 [x][y - 1][z]) cnt ++;
                    if (b1 [x][y + 1][z]) cnt ++;
                    if (b1 [x][y][z - 1]) cnt ++;
                    if (b1 [x][y][z + 1]) cnt ++;
                    if (cnt == 2){
                        int r = bfs2 (x, y, z);
                        if (r > -1){
                            res += r;
                            flag = 1;
                        }
                    }
                }
            }
        }
        if (!flag) break;
    }

    if (res >= 0){
        for (int x = 1; x <= 15; x ++){
            for (int y = 1; y <= 15; y ++){
                for (int z = 1; z <= 15; z ++){
                    b [x][y][z] = b1 [x][y][z];
                }
            }
        }
        return res;
    }
    return -1;
}

int main (){

    ios::sync_with_stdio (false);
    cin.tie (0);

    cin >> n;
    for (int i = 0; i < n; i ++){
        int x, y, z;
        cin >> x >> y >> z;
        b [x + 1][y + 1][z + 1] = 1;
    }
    for (int i = 0; i < 5000; i ++){
        for (int x = 1; x <= 15; x ++){
            for (int y = 1; y <= 15; y ++){
                for (int z = 1; z <= 15; z ++){
                    if (b [x][y][z]) continue;
                    int cnt = 0;
                    if (b [x - 1][y][z]) cnt ++;
                    if (b [x + 1][y][z]) cnt ++;
                    if (b [x][y - 1][z]) cnt ++;
                    if (b [x][y + 1][z]) cnt ++;
                    if (b [x][y][z - 1]) cnt ++;
                    if (b [x][y][z + 1]) cnt ++;
                    if (cnt >= 3) b [x][y][z] = 1;
                }
            }
        }
    }

    for (int i = 0; i < 5000; i ++){
        bool flag = 0;
        for (int x = 1; x <= 15; x ++){
            for (int y = 1; y <= 15; y ++){
                for (int z = 1; z <= 15; z ++){
                    if (b [x][y][z]) continue;
                    int cnt = 0;
                    if (b [x - 1][y][z]) cnt ++;
                    if (b [x + 1][y][z]) cnt ++;
                    if (b [x][y - 1][z]) cnt ++;
                    if (b [x][y + 1][z]) cnt ++;
                    if (b [x][y][z - 1]) cnt ++;
                    if (b [x][y][z + 1]) cnt ++;
                    if (cnt == 2){
                        int r = bfs (x, y, z);
                        if (r > -1) flag = 1;
                    }
                }
            }
        }
        if (!flag) break;
    }

    int ans = 0;
    for (int x = 1; x <= 15; x ++){
        for (int y = 1; y <= 15; y ++){
            for (int z = 1; z <= 15; z ++){
                if (!b [x][y][z]) continue;
                int cnt = 0;
                if (b [x - 1][y][z]) cnt ++;
                if (b [x + 1][y][z]) cnt ++;
                if (b [x][y - 1][z]) cnt ++;
                if (b [x][y + 1][z]) cnt ++;
                if (b [x][y][z - 1]) cnt ++;
                if (b [x][y][z + 1]) cnt ++;
                ans += 6 - cnt;
            }
        }
    }
    cout << ans << '\n';

}
/*
18
0 0 0
0 0 1
0 0 2
0 1 0
0 1 1
0 1 2
1 1 0
1 1 1
1 1 2
2 1 0
2 1 1
2 1 2
3 1 0
3 1 1
3 1 2
3 0 0
3 0 1
3 0 2
*/
