#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
/// pet minuti samo
/// iskat i se molqt pak pred moqta vrata
/// az puk iskam samo teb
/// da me vidqt nqmat kusmet
/// pet minuti samo
/// kilometri biqt, nqkoga bih gi za teb
/// snimkite predi i sled
/// stanah az momiche ot led

const int maxn = 53;

int n;
bool is[maxn][maxn];

void read()
{
    cin >> n;
    for (int i = 1; i <= n; i++)
    {
        int a, b, c;
        cin >> a >> b >> c;

        is[a][b] = true;
    }
}

vector <pair <int, int> > comp;
bool used[maxn][maxn];
void dfs(int x, int y)
{
    if (x < 0 || x >= 50 || y < 0 || y >= 50 || !is[x][y] || used[x][y])
        return;

    comp.push_back({x, y});
    used[x][y] = true;

    dfs(x+1, y);
    dfs(x-1, y);
    dfs(x, y-1);
    dfs(x, y+1);
}

struct polygon
{
    int area, all, inner;
    polygon() {area = all = inner = 0;}
    polygon(int area, int all, int inner)
    {
        this->area = area;
        this->all = all;
        this->inner = inner;
    }
};

vector <vector <pair <int, int> > > comps;
vector <polygon> v;
vector <int> adj[maxn * maxn];
bool is_inside[maxn][maxn];
bool is_outer[maxn][maxn];

void dfs1(int x, int y)
{
    if (x > 50 || y > 50 || x < 0 || y < 0 || !is_inside[x][y] || is_outer[x][y])
        return;

    is_inside[x][y] = false;
    dfs1(x+1, y);
    dfs1(x-1, y);
    dfs1(x, y+1);
    dfs1(x, y-1);
}

bool cmp(int a, int b)
{
    return v[a].area > v[b].area;
}

int dp[maxn * maxn];
bool used1[maxn * maxn];
void dfs2(int idx)
{
    used1[idx] = true;
    //dp[idx] = v[idx].area * 2 + v[idx].all - v[idx].inner;
    dp[idx] = INT_MAX;

    int alt = v[idx].all + (int)comps[idx].size() * 2;
    sort (adj[idx].begin(), adj[idx].end());
    for (auto i: adj[idx])
        if (!used1[i])
        {
            dfs2(i);
            alt += dp[i];
        }

    dp[idx] = min(dp[idx], alt);
}

void solve()
{
    for (int i = 0; i < 50; i++)
        for (int j = 0; j < 50; j++)
        if (is[i][j] && !used[i][j])
    {
        comp.clear();
        dfs(i, j);

        comps.push_back(comp);
    }

    v.resize((int)comps.size());
    for (int i = 0; i < (int)comps.size(); i++)
    {
        memset(is_inside, true, sizeof(is_inside));
        memset(is_outer, false, sizeof(is_outer));

        for (auto j: comps[i])
            is_outer[j.first][j.second] = true;

        dfs1(50, 50);

        for (int j = 0; j < 50; j++)
            for (int k = 0; k < 50; k++)
                if (is_inside[j][k])
                v[i].area++;

        for (auto j: comps[i])
        {
            if (j.first == 0)
                v[i].all++;

            else
                if (!is[j.first-1][j.second])
            {
                v[i].all++;
                if (is_inside[j.first-1][j.second])
                    v[i].inner++;
            }

            if (j.first == 49)
                v[i].all++;

            else
                if (!is[j.first+1][j.second])
            {
                v[i].all++;
                if (is_inside[j.first+1][j.second])
                    v[i].inner++;
            }

            if (j.second == 0)
                v[i].all++;

            else
                if (!is[j.first][j.second-1])
            {
                v[i].all++;
                if (is_inside[j.first][j.second-1])
                    v[i].inner++;
            }

            if (j.second == 49)
                v[i].all++;

            else
                if (!is[j.first][j.second+1])
            {
                v[i].all++;
                if (is_inside[j.first][j.second+1])
                    v[i].inner++;
            }
        }

        for (int j = 0; j < (int)comps.size(); j++)
        {
            if (i == j)
                continue;

            bool f = true;
            for (auto t: comps[j])
                if (!is_inside[t.first][t.second])
            {
                f = false;
                break;
            }

            if (f)
                adj[i].push_back(j);
        }
    }

    vector <int> order;
    for (int i = 0; i < (int)comps.size(); i++)
        order.push_back(i);

    int ans = 0;
    sort (order.begin(), order.end());
    for (auto i: order)
        if (!used1[i])
    {
        dfs2(i);
        ans += dp[i];
    }

    cout << ans << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();
}

/*
3
0 0 0
0 1 0
1 1 0
*/

/*
8
0 0 0
0 1 0
0 2 0
1 0 0
1 2 0
2 0 0
2 1 0
2 2 0
*/

/*
17
0 0 0
1 0 0
2 0 0
3 0 0
4 0 0
0 1 0
4 1 0
0 2 0
4 2 0
0 3 0
4 3 0
0 4 0
1 4 0
2 4 0
3 4 0
4 4 0
2 2 0
*/
