#include<iostream>
#include<vector>
#include<map>
#include<stdlib.h>
#include<random>
#include "playlists.h"
using namespace std;
vector<vector<int> >m_playlists;

static std::mt19937 mrand(69);

int gn,gk,gs;
double gp;
map<pair<int,int>,int> inds;
map<pair<pair<int,int>,int>,int>inds2;
int state=0;
int gl;
int cnts[1000];
vector<vector<int> > makePlaylists(int n, int k, int s, double p){
    gn=n;
    gs=s;
    gk=k;
    gp=p;
    if(s>=n){
        state=1;

        for(int i=0;i<n;i++){
            vector<int>playlist;
            for(int j=0;j<k;j++){
                playlist.push_back(i);
            }
            m_playlists.push_back(playlist);
        }
        return m_playlists;
    }else if((double)(s-1)/(double)n>p){
        state=4;
        vector<int>playlist;
        for(int i=0;i<s-1;i++){
            playlist.clear();
            for(int j=0;j<k;j++){
                playlist.push_back(i);
            }
            m_playlists.push_back(playlist);
        }
        for(int i=s-1;i<n;i++){
            playlist.clear();
            for(int j=0;j<k;j++){
                playlist.push_back(s-1);
            }
            m_playlists.push_back(playlist);
        }
        return m_playlists;
    }else if(s*(s-1)/2>=n){
        state=2;
        int l=0;
        for(int i=0;i<n;i++){
            if(i+(s-i)*(s-i-1)/2>=n){
                l=i;
            }else{
                break;
            }
        }
        gl=l;
        vector<int>playlist;
        for(int i=0;i<l;i++){
            playlist.clear();
            for(int j=0;j<k;j++){
                playlist.push_back(i);
            }
            m_playlists.push_back(playlist);
        }
        for(int i=l;i<s;i++){
            for(int j=i+1;j<s;j++){
                playlist.clear();
                for(int c=0;c<k;c++){
                    if(c<k/2){
                        playlist.push_back(i);
                    }else{
                        playlist.push_back(j);
                    }
                }
                inds[{i,j}]=m_playlists.size();
                m_playlists.push_back(playlist);
                if(m_playlists.size()==n){
                    return m_playlists;
                }
            }
        }
    }else if(s*(s-1)*(s-1)/6>=n){
        state=3;
        int l=0;
        for(int i=0;i<n;i++){
            if(i+(s-i)*(s-i-1)*(s-i-2)/6>=n){
                l=i;
            }else{
                break;
            }
        }
        gl=l;
        vector<int>playlist;
        for(int i=0;i<l;i++){
            playlist.clear();
            for(int j=0;j<k;j++){
                playlist.push_back(i);
            }
            m_playlists.push_back(playlist);
        }
        for(int i=gl;i<s;i++){
            for(int j=i+1;j<s;j++){
                for(int a=j+1;a<s;a++){
                    playlist.clear();
                    for(int c=0;c<k;c++){
                        if(c<k/3){
                            playlist.push_back(i);
                        }else if(c<k*2/3){
                            playlist.push_back(j);
                        }else{
                            playlist.push_back(a);
                        }
                    }
                    inds2[{{i,j},a}]=m_playlists.size();
                    m_playlists.push_back(playlist);
                    if(m_playlists.size()==n){
                        return m_playlists;
                    }
                }
            }
        }
    }
    return m_playlists;
}
double total=0;
int guessPlaylist(){
    if(state==1){
        if(total>20000.0*gp){
            //cout<<20000.0*gp<<endl;
            total++;
            return 0;
        }
        int first=nextSong();
        total++;
        return first;
    }
    if(state==2){
        if(total>20000.0*gp){
                if(gp<0.15){
                    return 0;
                }
            int first=nextSong();
            total++;
            if(first<gl){
                return first;
            }
            return inds[{gl,first}];
        }
        int first=nextSong();
        total++;
        if(first<gl){
            return first;
        }
        int second=first;
        while(second==first){
            second=nextSong();
        }
        if(first>second)swap(first,second);
        //cout<<first<<" "<<second<<endl;
        return inds[{first,second}];
    }
    if(state==3){
        if(total>20000.0*gp){
            if(gp<0.15){
                return 0;
            }
            //cout<<20000.0*gp<<endl;
            total++;
            int first=nextSong();
            if(first<gl){
                return first;
            }
            return inds2[{{gl,gl+1},first}];
        }
        int first=nextSong();
        if(first<gl){
            return first;
        }
        int second=first;
        int third=first;
        while(second==first){
            second=nextSong();
        }
        while(third==first || third==second){
            third=nextSong();
        }
        if(first>second)swap(first,second);
        if(second>third)swap(second,third);
        if(first>second)swap(first,second);
        //cout<<first<<" "<<second<<endl;
        total++;
        return inds2[{{first,second},third}];
    }else if(state==4){
        if(total>20000.0*gp){
            //cout<<20000.0*gp<<endl;
            total++;
            return 0;
        }
        int first=nextSong();
        if(first!=gs-1){
            total++;
        }
        return first;
    }
}
