#include<iostream>
using namespace std;
int tab[100][100];
void spread(int x,int y){
    if(x<0 || y<0 || x>60 || y>60 || tab[x][y]==1 || tab[x][y]==2){
        return;
    }
    tab[x][y]=2;
    spread(x-1,y);
    spread(x+1,y);
    spread(x,y-1);
    spread(x,y+1);
}
int area(int x,int y){
    if(x<0 || y<0 || x>60 || y>60 || tab[x][y]==1 || tab[x][y]==3){
        return 0;
    }
    tab[x][y]=3;
    int ans=1;
    ans+=area(x-1,y);
    ans+=area(x+1,y);
    ans+=area(x,y-1);
    ans+=area(x,y+1);
    return ans;
}
int perim(int x, int y){
    if(x<0 || y<0 || x>60 || y>60 || tab[x][y]==1 || tab[x][y]==4){
        return 0;
    }
    tab[x][y]=4;
    int ans=0;
    if(x>0 && tab[x-1][y]==1){
        ans++;
    }
    if(x<60 && tab[x+1][y]==1){
        ans++;
    }
    if(y>0 && tab[x][y-1]==1){
        ans++;
    }
    if(y<60 && tab[x][y+1]==1){
        ans++;
    }
    ans+=perim(x-1,y);
    ans+=perim(x+1,y);
    ans+=perim(x,y-1);
    ans+=perim(x,y+1);
    return ans;
}
int main(){
    int n;
    cin>>n;
    for(int i=0;i<n;i++){
        int x,y,z;
        cin>>x>>y>>z;
        x++;
        y++;
        z++;
        tab[x][y]=1;
    }
    spread(0,0);
    int ans=0;
    for(int x=1;x<=60;x++){
        for(int y=1;y<=60;y++){
            if(tab[x][y]==0){
                int a=area(x,y),b=perim(x,y);
                //cout<<a<<" "<<b<<endl;
                //ans+=min(2*area(x,y),perim(x,y));
                if(a*2<b){
                    ans-=b;
                    ans+=a*2;
                }
            }
        }
    }
    for(int x=1;x<60;x++){
        for(int y=1;y<60;y++){
            if(tab[x][y]!=1)continue;
            if(tab[x-1][y]!=1)ans++;
            if(tab[x+1][y]!=1)ans++;
            if(tab[x][y-1]!=1)ans++;
            if(tab[x][y+1]!=1)ans++;
        }
    }
    ans+=n*2;
    cout<<ans<<endl;
    return 0;
}
