#include<bits/stdc++.h>
#include "playlists.h"
using namespace std;
int nn, kk, ss, needed;
double pp;
int bits;
vector<vector<int>> makePlaylists(int n, int k, int s, double p) {
    nn = n;pp = p;ss = s;kk = k;
    needed = ceil(p*20000);
    bits = 32 - __builtin_clz(n-1);
    //cout<<bits<<endl;
    vector<vector<int>> res;
    for(int i = 0 ; i < n; i++) {
        vector<int> playlist;
        for(int bit = 0; bit < bits; bit++) {
            playlist.push_back((bool)(i & (1<<bit)) + 2*bit);
        }
        int pos = 0;
        while(playlist.size() < k) {
            playlist.push_back(playlist[pos++]);
        }
        res.push_back(playlist);
    }
    /*for(int i = 0; i < res.size(); i++) {
        for(int j = 0; j < res[i].size(); j++) {
            cout<<res[i][j]<<" ";
        }
        cout<<endl;
    }*/
    return res;
}
int correctlyGuessed = 0;

int guessPlaylist() {
    if(correctlyGuessed > needed) {
        return 0;
    }
    int bitsleft = bits;
    int res = 0;
    vector<bool> guessed(bits,false);
    while(bitsleft > 0) {
        int song = nextSong();
        int song_bit = song >> 1;
        int song_val = song & 1;
        if(!guessed[song_bit]) {
            guessed[song_bit] = true;
            if(song_val) {
                res += 1 << song_bit;
            }
            bitsleft--;
        }
    }
    correctlyGuessed++;
    return res;
}
