#include <bits/stdc++.h>
#pragma GCC optimize "-O3"
#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl
using namespace std;
struct Room {
    int x;
    int y;
    int z;
    Room(int x, int y, int z) {
        this->x = x;
        this->y = y;
        this->z = z;
    }
    bool operator <(const Room &rhs) const {
        return tie(this->x, this->y, this->z) < tie(rhs.x, rhs.y, rhs.z);
    }
};
void setIO() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}
int n;
vector<Room> rooms;
void read() {
    cin >> n;
    rooms.reserve(n);
    for (int i = 0; i < n; i++) {
        int x, y, z;
        cin >> x >> y >> z;
        rooms.emplace_back(x, y, z);
    }
}
void solve() {
    sort(rooms.begin(), rooms.end());
    int answer = 6 * n;
    for (int i = 1; i < n; i++) {
        int dist = rooms[i].x - rooms[i - 1].x;
        int newAnswer = answer - 6 * dist - 1;
        newAnswer += (4 * dist);
        newAnswer++;

        if (newAnswer < answer) {
            answer = newAnswer;
        }
    }

    cout << answer << endl;
}
int main() {
    setIO();
    read();
    solve();
}
