# include <bits/stdc++.h>
//#pragma GCC optimize ("O3")
//#pragma GCC target ("sse4")
using namespace std;
const int maxn = 1e4+5;
const int maxtask = 1e6+5;
int n,m;
vector <int> g[maxn];
vector <pair <int,int> > task[maxn];
int tasks[maxn];
int ans[maxtask];
int groups[maxn];
struct node
{
    int prev;
    int next;
    int id;
};
node p[maxn];
bool has[2502][2502];
void restore(int s)
{
    int i;
    int last = 0;
    for(i=1;i<=n;i++)
    {
        if(groups[i]!=s)continue;
        p[i].id = i;
        p[i].prev = last;
        p[last].next = i;
        last = i;
    }

    p[0].prev = -1;

    p[last].next = -1;
}
void del(int v)
{
    int prev=  p[v].prev;
    int next = p[v].next;
    if(prev!=-1)
        p[prev].next = next;
    if(next!=-1)
        p[next].prev = prev;
}
int dist[maxn];
int vis[maxn],visid;
 queue <pair <int,int> > q;
  void dfs(int v, int s)
 {
   //  cout<<v<<"->"<<s<<endl;
     groups[v] = s;
     del(v);
     queue <int> q;
q.push(v);
     int i=0;
     while(!q.empty())
     {
         v = q.front();
         q.pop();
       //  cout<<v<<"->"<<s<<endl;
         groups[v] = s;
         int  u = p[0].next;
         i=0;
         while(u!=-1)
         {
              while(i<g[v].size()&&g[v][i]<u)i++;
            if(i<g[v].size()&&u==g[v][i])
            {
                u = p[u].next;
                continue;
            }
            q.push(u);

            int next = p[u].next;
            del(u);
            u = next;
         }

            //cout<<"go from "<<v<<" "<<u<<endl;

     }
 }
void bfs(int t)
{
    //cout<<t<<" :"<<endl;
    visid++;
while(!q.empty())q.pop();
    q.push({t,0});
    del(t);
    vis[t] = visid;
    dist[t] = 0;

    int v,u,d;
    int i;
    while(tasks[t]>0&&!q.empty())
    {
        v = q.front().first;
        d = q.front().second;

        q.pop();
       // cout<<v<<" "<<d<<endl;
        u = p[0].next;
        i = 0;
        while(tasks[t]>0&&u!=-1)
        {
         //   cout<<"Check "<<u<<endl;
            while(i<g[v].size()&&g[v][i]<u)i++;
            if(i<g[v].size()&&u==g[v][i])
            {
                u = p[u].next;
                continue;
            }
            vis[u] = visid;
            dist[u] = d+1;
            if(has[t][u])
            {
                tasks[t]--;
                has[t][u] = 0;
            }
            /*if(st[t].find(u)!=st[t].end())
            {
                st[t].erase(u);
                st[u].erase(t);
                tasks[t]--;
            }*/
           // cout<<v<<"->"<<u<<" "<<d+1<<endl;
            q.push({u,d+1});
            int prev = u;
            u  = p[u].next;
            del(prev);
        }
    }
    for(i=0;i<task[t].size();i++)
    {
        v = task[t][i].first;
        int id = task[t][i].second;
        //if(ans[id]==-1)continue;
      // if(vis[v]!=visid)ans[id] = -1;
        //else
            ans[id] = dist[v];
          //  if(has[v][t]) {tasks[v]--;}

       // has[v][t] = 0;
        has[t][v] = 0;
    }
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cin>>n>>m;
    int i,j;
    int u,v;
    for(i=1;i<=m;i++)
    {
        cin>>u>>v;
        u++;
        v++;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    for(i=1;i<=n;i++)
        sort(g[i].begin(),g[i].end());
        restore(0);
         for(i=1;i<=n;i++)
        {
            if(groups[i]==0)dfs(i,i);
            //cout<<i<<" "<<groups[i]<<endl;
        }
    int q;
    cin>>q;
    for(i=1;i<=q;i++)
    {
        cin>>u>>v;
        u++;
        v++;
        if(u==v)
        {
            ans[i] = 0;
            continue;
        }
         if(groups[u]!=groups[v])
        {
            ans[i] = -1;
            continue;
        }
        if(u>v)swap(u,v);
        if(!has[v][u]){
        tasks[u]++;
        //tasks[v]++;
        }
        has[u][v] = 1;
        //has[v][u] = 1;

        task[u].push_back({v,i});
       // task[v].push_back({u,i});
       // st[u].insert(v);
       // st[v].insert(u);
    }
    for(i=1;i<=n;i++)
    {
       //cout<<i<<" "<<tasks[i]<<endl;
        if(tasks[i]==0)continue;
        restore(groups[i]);
       // tasks[i] = st[i].size();
        bfs(i);
    }
    for(i=1;i<=q;i++)
        cout<<ans[i]<<endl;

    return 0;
}
/*
6 10
0 2
5 0
4 1
1 3
1 5
2 5
2 4
4 0
5 3
4 5
10
1 4
3 2
2 3
2 4
2 0
2 4
4 4
3 2
4 1
0 5
*/
